/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

var button_index = require('../button/index.js');
var divider_index = require('../divider/index.js');
var fab_index = require('../fab/index.js');
var icon_index = require('../icon/index.js');
var layout_index = require('../layout/index.js');
var link_index = require('../link/index.js');
var backTop_index = require('../back-top/index.js');
var drawer_index = require('../drawer/index.js');
var indexes_index = require('../indexes/index.js');
var navbar_index = require('../navbar/index.js');
var sideBar_index = require('../side-bar/index.js');
var steps_index = require('../steps/index.js');
var tabBar_index = require('../tab-bar/index.js');
var tabs_index = require('../tabs/index.js');
var calendar_index = require('../calendar/index.js');
var cascader_index = require('../cascader/index.js');
var checkbox_index = require('../checkbox/index.js');
var colorPicker_index = require('../color-picker/index.js');
var dateTimePicker_index = require('../date-time-picker/index.js');
var form_index = require('../form/index.js');
var input_index = require('../input/index.js');
var picker_index = require('../picker/index.js');
var radio_index = require('../radio/index.js');
var rate_index = require('../rate/index.js');
var search_index = require('../search/index.js');
var slider_index = require('../slider/index.js');
var stepper_index = require('../stepper/index.js');
var switch_index = require('../switch/index.js');
var textarea_index = require('../textarea/index.js');
var treeSelect_index = require('../tree-select/index.js');
var upload_index = require('../upload/index.js');
var avatar_index = require('../avatar/index.js');
var badge_index = require('../badge/index.js');
var cell_index = require('../cell/index.js');
var collapse_index = require('../collapse/index.js');
var countDown_index = require('../count-down/index.js');
var empty_index = require('../empty/index.js');
var footer_index = require('../footer/index.js');
var grid_index = require('../grid/index.js');
var image_index = require('../image/index.js');
var imageViewer_index = require('../image-viewer/index.js');
var list_index = require('../list/index.js');
var progress_index = require('../progress/index.js');
var result_index = require('../result/index.js');
var skeleton_index = require('../skeleton/index.js');
var sticky_index = require('../sticky/index.js');
var swiper_index = require('../swiper/index.js');
var table_index = require('../table/index.js');
var tag_index = require('../tag/index.js');
var actionSheet_index = require('../action-sheet/index.js');
var dialog_index = require('../dialog/index.js');
var dropdownMenu_index = require('../dropdown-menu/index.js');
var guide_index = require('../guide/index.js');
var loading_index = require('../loading/index.js');
var message_index = require('../message/index.js');
var noticeBar_index = require('../notice-bar/index.js');
var overlay_index = require('../overlay/index.js');
var popover_index = require('../popover/index.js');
var popup_index = require('../popup/index.js');
var pullDownRefresh_index = require('../pull-down-refresh/index.js');
var swipeCell_index = require('../swipe-cell/index.js');
var configProvider_index = require('../config-provider/index.js');
var drawer_plugin = require('../drawer/plugin.js');
var loading_plugin = require('../loading/plugin.js');
var toast_plugin = require('../toast/plugin.js');

var components = /*#__PURE__*/Object.freeze({
	__proto__: null,
	Button: button_index.Button,
	Divider: divider_index.Divider,
	Fab: fab_index.Fab,
	Icon: icon_index.Icon,
	Row: layout_index.Row,
	Col: layout_index.Col,
	Link: link_index.Link,
	BackTop: backTop_index.BackTop,
	DrawerPlugin: drawer_plugin["default"],
	Drawer: drawer_index.Drawer,
	Indexes: indexes_index.Indexes,
	IndexesAnchor: indexes_index.IndexesAnchor,
	Navbar: navbar_index.Navbar,
	SideBar: sideBar_index.SideBar,
	SideBarItem: sideBar_index.SideBarItem,
	StepItem: steps_index.StepItem,
	Steps: steps_index.Steps,
	TabBar: tabBar_index.TabBar,
	TabBarItem: tabBar_index.TabBarItem,
	Tabs: tabs_index.Tabs,
	TabPanel: tabs_index.TabPanel,
	Calendar: calendar_index.Calendar,
	Cascader: cascader_index.Cascader,
	Checkbox: checkbox_index.Checkbox,
	CheckboxGroup: checkbox_index.CheckboxGroup,
	ColorPicker: colorPicker_index.ColorPicker,
	DateTimePicker: dateTimePicker_index.DateTimePicker,
	Form: form_index.Form,
	FormItem: form_index.FormItem,
	Input: input_index.Input,
	Picker: picker_index.Picker,
	Cascade: picker_index.Cascade,
	RadioGroup: radio_index.RadioGroup,
	Radio: radio_index.Radio,
	Rate: rate_index.Rate,
	Search: search_index.Search,
	Slider: slider_index.Slider,
	Stepper: stepper_index.Stepper,
	Switch: switch_index.Switch,
	Textarea: textarea_index.Textarea,
	TreeSelect: treeSelect_index.TreeSelect,
	Upload: upload_index.Upload,
	Avatar: avatar_index.Avatar,
	AvatarGroup: avatar_index.AvatarGroup,
	Badge: badge_index.Badge,
	Cell: cell_index.Cell,
	CellGroup: cell_index.CellGroup,
	Collapse: collapse_index.Collapse,
	CollapsePanel: collapse_index.CollapsePanel,
	CountDown: countDown_index.CountDown,
	Empty: empty_index.Empty,
	Footer: footer_index.Footer,
	Grid: grid_index.Grid,
	GridItem: grid_index.GridItem,
	Image: image_index.Image,
	ImageViewer: imageViewer_index.ImageViewer,
	List: list_index.List,
	Progress: progress_index.Progress,
	Result: result_index.Result,
	Skeleton: skeleton_index.Skeleton,
	Sticky: sticky_index.Sticky,
	Swiper: swiper_index.Swiper,
	SwiperItem: swiper_index.SwiperItem,
	Table: table_index.Table,
	Tag: tag_index.Tag,
	CheckTag: tag_index.CheckTag,
	_ActionSheet: actionSheet_index._ActionSheet,
	DialogPlugin: dialog_index.DialogPlugin,
	DropdownMenu: dropdownMenu_index.DropdownMenu,
	DropdownItem: dropdownMenu_index.DropdownItem,
	Guide: guide_index.Guide,
	LoadingPlugin: loading_plugin.LoadingPlugin,
	Loading: loading_index.Loading,
	MessagePlugin: message_index.MessagePlugin,
	NoticeBar: noticeBar_index.NoticeBar,
	Overlay: overlay_index.Overlay,
	Popover: popover_index.Popover,
	Popup: popup_index.Popup,
	PullDownRefresh: pullDownRefresh_index.PullDownRefresh,
	SwipeCell: swipeCell_index.SwipeCell,
	ToastPlugin: toast_plugin.ToastPlugin,
	ConfigProvider: configProvider_index.ConfigProvider
});

exports.components = components;
//# sourceMappingURL=dep-53382184.js.map
