import type { BasicColorFormat, ColorInputProp } from './types';
export declare const TD_COLOR_USED_COLORS_MAX_SIZE = 100;
export declare const COLOR_MODES: {
    monochrome: string;
    'linear-gradient': string;
};
export declare const DEFAULT_COLOR = "#001F97";
export declare const DEFAULT_LINEAR_GRADIENT = "linear-gradient(90deg, rgba(241,29,0,1) 0%, rgba(73,106,220,1) 100%);";
export declare const DEFAULT_SYSTEM_SWATCH_COLORS: string[];
export declare const FORMATS: readonly ["HEX", "RGB", "HSL", "HSV", "CMYK", "CSS"];
export declare const ALPHA_FORMAT_MAP: {
    readonly HEX: "HEX8";
    readonly RGB: "RGBA";
    readonly HSL: "HSLA";
    readonly HSV: "HSVA";
};
export declare const COLOR_FORMAT_INPUTS: Record<BasicColorFormat, ColorInputProp[]>;
export declare const SATURATION_PANEL_DEFAULT_WIDTH = 230;
export declare const SATURATION_PANEL_DEFAULT_HEIGHT = 168;
export declare const SLIDER_DEFAULT_WIDTH = 186;
export declare const GRADIENT_SLIDER_DEFAULT_WIDTH = 176;
