/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var isObject = require('../../../_chunks/dep-48b1ccc0.js');
var isFunction = require('../../../_chunks/dep-9059ceab.js');
require('@babel/runtime/helpers/typeof');
require('../../../_chunks/dep-a9c0c920.js');

var hasOwnProperty = Object.prototype.hasOwnProperty;
var hasOwn = function hasOwn(val, key) {
  return hasOwnProperty.call(val, key);
};
var getPropertyValFromObj = function getPropertyValFromObj(val, key) {
  return hasOwn(val, key) ? val[key] : void 0;
};
var objectToString = Object.prototype.toString;
var toTypeString = function toTypeString(value) {
  return objectToString.call(value);
};
var isPlainObject = function isPlainObject(val) {
  return toTypeString(val) === "[object Object]";
};
var isPromise = function isPromise(val) {
  return (isObject.isObject(val) || isFunction.isFunction(val)) && isFunction.isFunction(val.then) && isFunction.isFunction(val.catch);
};

exports.getPropertyValFromObj = getPropertyValFromObj;
exports.hasOwn = hasOwn;
exports.isPlainObject = isPlainObject;
exports.isPromise = isPromise;
//# sourceMappingURL=general.js.map
