/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _common_js_utils_helper = require('./helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/defineProperty');
require('../../../_chunks/dep-1f68b3d8.js');
require('../../../_chunks/dep-01f34845.js');
require('../../../_chunks/dep-51f8b65c.js');
require('../../../_chunks/dep-a9c0c920.js');
require('@babel/runtime/helpers/typeof');
require('../../../_chunks/dep-161c0305.js');
require('../../../_chunks/dep-b1b7627b.js');
require('../../../_chunks/dep-619e29e1.js');

function getScrollbarWidthWithCSS() {
  var defaultScrollbarWidth = 6;
  if (typeof navigator === "undefined" || !navigator) return defaultScrollbarWidth;
  if (/(Chrome|Safari)/i.test(navigator.userAgent)) return defaultScrollbarWidth;
  var scrollDiv = document.createElement("div");
  scrollDiv.style.cssText = "width: 99px; height: 99px; overflow: scroll; position: absolute; top: -9999px;";
  document.body.appendChild(scrollDiv);
  var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
  document.body.removeChild(scrollDiv);
  if (/Firefox/.test(navigator.userAgent)) {
    scrollbarWidth -= 4;
  }
  if (_common_js_utils_helper.getIEVersion() <= 11) {
    scrollbarWidth = 12;
  }
  return scrollbarWidth;
}
function getScrollbarWidth() {
  var container = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.body;
  if (container === document.body) {
    return window.innerWidth - document.documentElement.clientWidth;
  }
  return container.offsetWidth - container.clientWidth;
}

exports.getScrollbarWidth = getScrollbarWidth;
exports.getScrollbarWidthWithCSS = getScrollbarWidthWithCSS;
//# sourceMappingURL=getScrollbarWidth.js.map
