/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var vue = require('vue');
var actionSheet_actionSheet = require('./action-sheet.js');
var shared_util = require('../shared/util.js');
require('@babel/runtime/helpers/slicedToArray');
require('./action-sheet-grid.js');
require('../grid/index.js');
require('../grid/grid.js');
require('../config.js');
require('../grid/props.js');
require('../hooks/useClass.js');
require('../_chunks/dep-977081b1.js');
require('../_chunks/dep-90d1f1f6.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-5b94d99d.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-b912c957.js');
require('dayjs');
require('../_chunks/dep-107d4340.js');
require('../_chunks/dep-f8610152.js');
require('../_chunks/dep-95fd413d.js');
require('../_chunks/dep-b99dd3a6.js');
require('../_chunks/dep-9059ceab.js');
require('../_chunks/dep-a9c0c920.js');
require('../_chunks/dep-48b1ccc0.js');
require('../_chunks/dep-7ede1657.js');
require('../_chunks/dep-11900ba0.js');
require('../_chunks/dep-b1b7627b.js');
require('../_chunks/dep-68999828.js');
require('../_chunks/dep-8c8ba0a8.js');
require('../_chunks/dep-161c0305.js');
require('../_chunks/dep-d8a9a6b3.js');
require('../_chunks/dep-4381ced7.js');
require('../_chunks/dep-533c057c.js');
require('../_chunks/dep-87690293.js');
require('../_chunks/dep-b55fb6e4.js');
require('../_chunks/dep-e11b336c.js');
require('../_chunks/dep-ec417fb3.js');
require('../_chunks/dep-51f8b65c.js');
require('../grid/grid-item.js');
require('../grid/grid-item-props.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-cc4bd331.js');
require('../_chunks/dep-fb55187e.js');
require('../_chunks/dep-65b2a290.js');
require('../_chunks/dep-51b8dcc5.js');
require('../_chunks/dep-2c45a7c8.js');
require('../_chunks/dep-edb64bb3.js');
require('../_chunks/dep-216eb455.js');
require('../_chunks/dep-e1ee8baa.js');
require('../image/index.js');
require('../image/image.js');
require('@vueuse/core');
require('tdesign-icons-vue-next');
require('../loading/index.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-1f68b3d8.js');
require('../_chunks/dep-01f34845.js');
require('../_chunks/dep-619e29e1.js');
require('../loading/icon/spinner.js');
require('../loading/props.js');
require('../shared/dom.js');
require('../loading/plugin.js');
require('../shared/component.js');
require('../image/props.js');
require('../badge/index.js');
require('../badge/badge.js');
require('../badge/props.js');
require('../shared/hover.js');
require('../swiper/index.js');
require('../swiper/swiper.js');
require('../swipe-cell/useSwipe.js');
require('../swiper/props.js');
require('../hooks/useVModel.js');
require('../swiper/swiper-item.js');
require('./action-sheet-list.js');
require('../button/index.js');
require('../button/button.js');
require('../button/props.js');
require('../form/hooks.js');
require('../_chunks/dep-fc7a09a0.js');
require('../popup/index.js');
require('../popup/popup.js');
require('../popup/props.js');
require('../overlay/index.js');
require('../overlay/overlay.js');
require('../overlay/props.js');
require('../hooks/useLockScroll.js');
require('../_util/useTouch.js');
require('../_util/getScrollParent.js');
require('../hooks/useTeleport.js');
require('../shared/render-tnode.js');
require('./props.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var instance = null;
var app;
function create(props) {
  if (!shared_util.isBrowser) return;
  var root = document.createElement("div");
  document.body.appendChild(root);
  var visible = vue.ref(false);
  var propsObject = _objectSpread({
    visible: visible
  }, props);
  if (instance) {
    instance.clear();
  }
  instance = actionSheet_actionSheet["default"];
  instance.clear = function (trigger) {
    app.unmount();
    root.remove();
    if (propsObject.onClose && trigger && trigger.trigger !== "overlay") {
      propsObject.onClose(trigger);
    }
    instance = null;
  };
  app = vue.createApp(instance, _objectSpread({}, propsObject));
  app.mount(root);
  vue.nextTick(function () {
    visible.value = true;
  });
  return instance;
}
function ActionSheet(props) {
  create(props);
}
ActionSheet.close = function (trigger) {
  if (instance) {
    instance.clear(trigger);
  }
};
ActionSheet.show = function (props) {
  create(props);
};
ActionSheet.install = function (app2) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  app2.component(name || actionSheet_actionSheet["default"].name, actionSheet_actionSheet["default"]);
};
var _ActionSheet = ActionSheet;

exports._ActionSheet = _ActionSheet;
exports["default"] = _ActionSheet;
//# sourceMappingURL=index.js.map
