/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var BadgeProps = {
  color: {
    type: String,
    default: ""
  },
  content: {
    type: [String, Function]
  },
  count: {
    type: [String, Number, Function],
    default: 0
  },
  dot: Boolean,
  maxCount: {
    type: Number,
    default: 99
  },
  offset: {
    type: Array
  },
  shape: {
    type: String,
    default: "circle",
    validator: function validator(val) {
      if (!val) return true;
      return ["circle", "square", "bubble", "ribbon"].includes(val);
    }
  },
  showZero: Boolean,
  size: {
    type: String,
    default: "medium",
    validator: function validator(val) {
      if (!val) return true;
      return ["medium", "large"].includes(val);
    }
  }
};

exports["default"] = BadgeProps;
//# sourceMappingURL=props.js.map
