import { TNode, KeysType } from '../common';
export interface TdCheckboxProps {
    block?: boolean;
    borderless?: boolean;
    checkAll?: boolean;
    checked?: boolean;
    defaultChecked?: boolean;
    modelValue?: boolean;
    content?: string | TNode;
    contentDisabled?: boolean;
    default?: string | TNode;
    disabled?: boolean;
    icon?: 'circle' | 'line' | 'rectangle' | boolean | Array<TNode | String>;
    indeterminate?: boolean;
    label?: string | TNode;
    maxContentRow?: number;
    maxLabelRow?: number;
    name?: string;
    placement?: 'left' | 'right';
    readonly?: boolean;
    value?: string | number | boolean;
    onChange?: (checked: boolean, context: {
        e: Event;
    }) => void;
}
export interface TdCheckboxGroupProps<T = CheckboxGroupValue> {
    borderless?: boolean;
    disabled?: boolean;
    keys?: KeysType;
    max?: number;
    name?: string;
    options?: Array<CheckboxOption>;
    readonly?: boolean;
    value?: T;
    defaultValue?: T;
    modelValue?: T;
    onChange?: (value: T, context: CheckboxGroupChangeContext) => void;
}
export declare type CheckboxOption = string | number | CheckboxOptionObj;
export interface CheckboxOptionObj extends TdCheckboxProps {
    text?: string;
}
export declare type CheckboxGroupValue = Array<string | number | boolean>;
export interface CheckboxGroupChangeContext {
    e: Event;
    current: string | number;
    option: CheckboxOption | TdCheckboxProps;
    type: 'check' | 'uncheck';
}
