export interface TdColorPickerProps {
    clearable?: boolean;
    enableAlpha?: boolean;
    fixed?: boolean;
    format?: 'HEX' | 'HEX8' | 'RGB' | 'RGBA' | 'HSL' | 'HSLA' | 'HSV' | 'HSVA' | 'CMYK' | 'CSS';
    swatchColors?: Array<string> | null | undefined;
    type?: TypeEnum;
    value?: string;
    defaultValue?: string;
    modelValue?: string;
    onChange?: (value: string, context: {
        color: ColorObject;
        trigger: ColorPickerChangeTrigger;
    }) => void;
    onPaletteBarChange?: (context: {
        color: ColorObject;
    }) => void;
}
export declare type TypeEnum = 'base' | 'multiple';
export declare type ColorPickerChangeTrigger = 'palette-hue-bar' | 'palette-alpha-bar' | 'preset';
export interface ColorObject {
    alpha: number;
    css: string;
    hex: string;
    hex8: string;
    hsl: string;
    hsla: string;
    hsv: string;
    hsva: string;
    rgb: string;
    rgba: string;
    value: number;
}
