import { GlobalConfigProvider } from './type';
import type { TdConfigProviderProps } from './type';
export * from './type';
export declare function useConfig<T extends keyof GlobalConfigProvider>(componentName?: T, componentLocale?: GlobalConfigProvider[T]): {
    t: <T_1>(pattern: T_1, ...args: any[]) => any;
    global: import("vue").ComputedRef<{} & (GlobalConfigProvider | ({
        readonly classPrefix: "t";
    } & {
        actionSheet: {
            cancel: string;
        };
        calendar: {
            title: string;
            confirm: string;
            weekdays: string[];
            monthTitle: string;
            months: string[];
        };
        cascader: {
            title: string;
            placeholder: string;
        };
        dropdownMenu: {
            reset: string;
            confirm: string;
        };
        dateTimePicker: {
            title: string;
            cancel: string;
            confirm: string;
            format: string;
            yearLabel: string;
            monthLabel: string;
            dateLabel: string;
            hourLabel: string;
            minuteLabel: string;
            secondLabel: string;
        };
        picker: {
            cancel: string;
            confirm: string;
        };
        pullDownRefresh: {
            loadingTexts: string[];
        };
        rate: {
            valueText: string;
            noValueText: string;
        };
        tabBar: {
            newsAriaLabel: string;
            moreNewsAriaLabel: string;
            haveMoreNewsAriaLabel: string;
            haveNewsAriaLabel: string;
        };
        table: {
            empty: string;
        };
        list: {
            loading: string;
            loadingMoreText: string;
            pulling: string;
            loosing: string;
            success: string;
        };
        upload: {
            progress: {
                uploadingText: string;
                waitingText: string;
                failText: string;
                successText: string;
            };
        };
        guide: {
            next: string;
            skip: string;
            finish: string;
            back: string;
        };
    }))[T] & GlobalConfigProvider[T]>;
    globalConfig: import("vue").ComputedRef<{} & (GlobalConfigProvider | ({
        readonly classPrefix: "t";
    } & {
        actionSheet: {
            cancel: string;
        };
        calendar: {
            title: string;
            confirm: string;
            weekdays: string[];
            monthTitle: string;
            months: string[];
        };
        cascader: {
            title: string;
            placeholder: string;
        };
        dropdownMenu: {
            reset: string;
            confirm: string;
        };
        dateTimePicker: {
            title: string;
            cancel: string;
            confirm: string;
            format: string;
            yearLabel: string;
            monthLabel: string;
            dateLabel: string;
            hourLabel: string;
            minuteLabel: string;
            secondLabel: string;
        };
        picker: {
            cancel: string;
            confirm: string;
        };
        pullDownRefresh: {
            loadingTexts: string[];
        };
        rate: {
            valueText: string;
            noValueText: string;
        };
        tabBar: {
            newsAriaLabel: string;
            moreNewsAriaLabel: string;
            haveMoreNewsAriaLabel: string;
            haveNewsAriaLabel: string;
        };
        table: {
            empty: string;
        };
        list: {
            loading: string;
            loadingMoreText: string;
            pulling: string;
            loosing: string;
            success: string;
        };
        upload: {
            progress: {
                uploadingText: string;
                waitingText: string;
                failText: string;
                successText: string;
            };
        };
        guide: {
            next: string;
            skip: string;
            finish: string;
            back: string;
        };
    }))[T] & GlobalConfigProvider[T]>;
    classPrefix: import("vue").ComputedRef<string>;
};
export declare const provideConfig: (props: TdConfigProviderProps) => import("vue").ComputedRef<{
    actionSheet?: import("./type").ActionSheetConfig;
    calendar?: import("./type").CalendarConfig;
    cascader?: import("./type").CascaderConfig;
    classPrefix?: string;
    dateTimePicker?: import("./type").DateTimePickerConfig;
    dropdownMenu?: import("./type").DropdownMenuConfig;
    guide?: import("./type").GuideConfig;
    list?: import("./type").ListConfig;
    picker?: import("./type").PickerConfig;
    pullDownRefresh?: import("./type").PullDownRefreshConfig;
    rate?: import("./type").RateConfig;
    tabBar?: import("./type").TabBarConfig;
    table?: import("./type").TableConfig;
    upload?: import("./type").UploadConfig;
}>;
