/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var CountDownProps = {
  autoStart: {
    type: Boolean,
    default: true
  },
  content: {
    type: [String, Function],
    default: "default"
  },
  format: {
    type: String,
    default: "HH:mm:ss"
  },
  millisecond: Boolean,
  size: {
    type: String,
    default: "medium",
    validator: function validator(val) {
      if (!val) return true;
      return ["small", "medium", "large"].includes(val);
    }
  },
  splitWithUnit: Boolean,
  theme: {
    type: String,
    default: "default",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "round", "square"].includes(val);
    }
  },
  time: {
    type: Number,
    required: true
  },
  onChange: Function,
  onFinish: Function
};

exports["default"] = CountDownProps;
//# sourceMappingURL=props.js.map
