import Dialog from './dialog';
import { WithInstallType } from '../shared';
import { TdDialogProps, DialogInstance } from './type';
import './style';
export declare type DialogType = 'alert' | 'confirm' | 'show';
declare type DialogApi = {
    show: (options: Partial<TdDialogProps> | string) => DialogInstance;
    alert: (options: Partial<TdDialogProps> | string) => DialogInstance;
    confirm: (options: Partial<TdDialogProps> | string) => DialogInstance;
};
export declare const DialogPlugin: WithInstallType<typeof Dialog> & DialogApi;
export default DialogPlugin;
declare module 'vue' {
    interface ComponentCustomProperties {
        $dialog: DialogApi;
    }
}
