import { TNode, KeysType } from '../common';
export interface TdDropdownMenuProps {
    closeOnClickOverlay?: boolean;
    direction?: 'down' | 'up';
    duration?: string | number;
    showOverlay?: boolean;
    zIndex?: number;
}
export interface TdDropdownItemProps {
    disabled?: boolean;
    footer?: TNode;
    keys?: KeysType;
    label?: string;
    multiple?: boolean;
    options?: Array<DropdownOption>;
    optionsColumns?: string | number;
    placement?: 'left' | 'right';
    value?: DropdownValue;
    defaultValue?: DropdownValue;
    modelValue?: DropdownValue;
    onChange?: (value: DropdownValue) => void;
    onConfirm?: (value: DropdownValue) => void;
    onReset?: (value: DropdownValue) => void;
}
export interface DropdownOption {
    label: string;
    disabled: boolean;
    value: DropdownValue;
}
export declare type DropdownValue = string | number | Array<DropdownValue>;
