/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var image_index = require('../image/index.js');
var footer_props = require('./props.js');
var config = require('../config.js');
var hooks_useClass = require('../hooks/useClass.js');
require('../image/image.js');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/defineProperty');
require('@vueuse/core');
require('tdesign-icons-vue-next');
require('../loading/index.js');
require('../loading/loading.js');
require('../loading/icon/gradient.js');
require('../_common/js/loading/circle-adapter.js');
require('../_common/js/utils/setStyle.js');
require('../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('../_chunks/dep-1f68b3d8.js');
require('../_chunks/dep-01f34845.js');
require('../_chunks/dep-51f8b65c.js');
require('../_chunks/dep-a9c0c920.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-161c0305.js');
require('../_chunks/dep-b1b7627b.js');
require('../_chunks/dep-619e29e1.js');
require('../loading/icon/spinner.js');
require('../loading/props.js');
require('../hooks/tnode.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-48b1ccc0.js');
require('../_chunks/dep-cc4bd331.js');
require('../_chunks/dep-fb55187e.js');
require('../_chunks/dep-65b2a290.js');
require('../_chunks/dep-51b8dcc5.js');
require('../_chunks/dep-2c45a7c8.js');
require('../_chunks/dep-edb64bb3.js');
require('../_chunks/dep-216eb455.js');
require('../_chunks/dep-9059ceab.js');
require('../_chunks/dep-e1ee8baa.js');
require('../_chunks/dep-ec417fb3.js');
require('../_chunks/dep-11900ba0.js');
require('../_chunks/dep-68999828.js');
require('../_chunks/dep-8c8ba0a8.js');
require('../_chunks/dep-b99dd3a6.js');
require('../shared/dom.js');
require('../loading/plugin.js');
require('../_chunks/dep-90d1f1f6.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-5b94d99d.js');
require('../_chunks/dep-b912c957.js');
require('dayjs');
require('../_chunks/dep-107d4340.js');
require('../_chunks/dep-f8610152.js');
require('../_chunks/dep-95fd413d.js');
require('../_chunks/dep-7ede1657.js');
require('../_chunks/dep-d8a9a6b3.js');
require('../_chunks/dep-4381ced7.js');
require('../_chunks/dep-533c057c.js');
require('../_chunks/dep-87690293.js');
require('../_chunks/dep-b55fb6e4.js');
require('../_chunks/dep-977081b1.js');
require('../_chunks/dep-e11b336c.js');
require('../shared/component.js');
require('../image/props.js');

var prefix = config["default"].prefix;
var _Footer = vue.defineComponent({
  name: "".concat(prefix, "-footer"),
  props: footer_props["default"],
  setup: function setup(props) {
    var footerClass = hooks_useClass.usePrefixClass("footer");
    var footerLinkClass = hooks_useClass.usePrefixClass("footer__link");
    var renderLogo = function renderLogo() {
      var logo = props.logo;
      if (!logo) {
        return;
      }
      return vue.createVNode("a", {
        "class": "".concat(footerClass.value, "__logo"),
        "href": logo.url,
        "target": logo.target
      }, [logo.icon && vue.createVNode(image_index.Image, {
        "class": "".concat(footerClass.value, "__icon"),
        "src": logo.icon
      }, null), logo.title && vue.createVNode("span", {
        "class": "".concat(footerClass.value, "__title")
      }, [logo.title])]);
    };
    var renderText = function renderText() {
      if (props.logo) {
        return;
      }
      return vue.createVNode("div", {
        "class": "".concat(footerClass.value, "__text")
      }, [props.text]);
    };
    var renderLink = function renderLink() {
      var links = props.links,
        logo = props.logo;
      var linksLength = links.length - 1;
      if (logo || linksLength < 0) {
        return;
      }
      return vue.createVNode("div", {
        "class": "".concat(footerLinkClass.value, "-list")
      }, [links.map(function (link, index) {
        return vue.createVNode(vue.Fragment, null, [vue.createVNode("a", {
          "href": link.url,
          "target": link.target,
          "class": "".concat(footerLinkClass.value, "-item")
        }, [link.name]), linksLength !== index && vue.createVNode("div", {
          "class": "".concat(footerLinkClass.value, "-line")
        }, [vue.createTextVNode("|")])]);
      })]);
    };
    return function () {
      return vue.createVNode("div", {
        "class": footerClass.value
      }, [renderLogo(), renderLink(), renderText()]);
    };
  }
});

exports["default"] = _Footer;
//# sourceMappingURL=footer.js.map
