/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var isBoolean = require('../_chunks/dep-fc7a09a0.js');
require('../_chunks/dep-a9c0c920.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-b1b7627b.js');

function useFormDisabled(extend) {
  var ctx = vue.getCurrentInstance();
  var propsDisabled = vue.computed(function () {
    return ctx === null || ctx === void 0 ? void 0 : ctx.props.disabled;
  });
  var _inject = vue.inject("formDisabled", /* @__PURE__ */Object.create(null)),
    disabled = _inject.disabled;
  return vue.computed(function () {
    if (isBoolean.isBoolean(propsDisabled.value)) {
      return propsDisabled.value;
    }
    if (isBoolean.isBoolean(extend === null || extend === void 0 ? void 0 : extend.value)) {
      return extend.value;
    }
    if (isBoolean.isBoolean(disabled === null || disabled === void 0 ? void 0 : disabled.value)) {
      return disabled.value;
    }
    return false;
  });
}

exports.useFormDisabled = useFormDisabled;
//# sourceMappingURL=hooks.js.map
