/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var components = require('./_chunks/dep-53382184.js');
var dialog_index = require('./dialog/index.js');
var message_index = require('./message/index.js');
var toast_plugin = require('./toast/plugin.js');
var drawer_plugin = require('./drawer/plugin.js');
var loading_plugin = require('./loading/plugin.js');
var actionSheet_index = require('./action-sheet/index.js');
var button_index = require('./button/index.js');
var divider_index = require('./divider/index.js');
var fab_index = require('./fab/index.js');
var icon_index = require('./icon/index.js');
var layout_index = require('./layout/index.js');
var link_index = require('./link/index.js');
var backTop_index = require('./back-top/index.js');
var drawer_index = require('./drawer/index.js');
var indexes_index = require('./indexes/index.js');
var navbar_index = require('./navbar/index.js');
var sideBar_index = require('./side-bar/index.js');
var steps_index = require('./steps/index.js');
var tabBar_index = require('./tab-bar/index.js');
var tabs_index = require('./tabs/index.js');
var calendar_index = require('./calendar/index.js');
var cascader_index = require('./cascader/index.js');
var checkbox_index = require('./checkbox/index.js');
var colorPicker_index = require('./color-picker/index.js');
var dateTimePicker_index = require('./date-time-picker/index.js');
var form_index = require('./form/index.js');
var input_index = require('./input/index.js');
var picker_index = require('./picker/index.js');
var radio_index = require('./radio/index.js');
var rate_index = require('./rate/index.js');
var search_index = require('./search/index.js');
var slider_index = require('./slider/index.js');
var stepper_index = require('./stepper/index.js');
var switch_index = require('./switch/index.js');
var textarea_index = require('./textarea/index.js');
var treeSelect_index = require('./tree-select/index.js');
var upload_index = require('./upload/index.js');
var avatar_index = require('./avatar/index.js');
var badge_index = require('./badge/index.js');
var cell_index = require('./cell/index.js');
var collapse_index = require('./collapse/index.js');
var countDown_index = require('./count-down/index.js');
var empty_index = require('./empty/index.js');
var footer_index = require('./footer/index.js');
var grid_index = require('./grid/index.js');
var image_index = require('./image/index.js');
var imageViewer_index = require('./image-viewer/index.js');
var list_index = require('./list/index.js');
var progress_index = require('./progress/index.js');
var result_index = require('./result/index.js');
var skeleton_index = require('./skeleton/index.js');
var sticky_index = require('./sticky/index.js');
var swiper_index = require('./swiper/index.js');
var table_index = require('./table/index.js');
var tag_index = require('./tag/index.js');
var dropdownMenu_index = require('./dropdown-menu/index.js');
var guide_index = require('./guide/index.js');
var loading_index = require('./loading/index.js');
var noticeBar_index = require('./notice-bar/index.js');
var overlay_index = require('./overlay/index.js');
var popover_index = require('./popover/index.js');
var popup_index = require('./popup/index.js');
var pullDownRefresh_index = require('./pull-down-refresh/index.js');
var swipeCell_index = require('./swipe-cell/index.js');
var configProvider_index = require('./config-provider/index.js');
require('@babel/runtime/helpers/defineProperty');
require('vue');
require('./dialog/dialog.js');
require('@babel/runtime/helpers/toConsumableArray');
require('tdesign-icons-vue-next');
require('./config.js');
require('./dialog/props.js');
require('./hooks/tnode.js');
require('./hooks/render-tnode.js');
require('./_chunks/dep-48b1ccc0.js');
require('@babel/runtime/helpers/typeof');
require('./_chunks/dep-51f8b65c.js');
require('./_chunks/dep-a9c0c920.js');
require('./_chunks/dep-161c0305.js');
require('./_chunks/dep-b1b7627b.js');
require('./_chunks/dep-cc4bd331.js');
require('./_chunks/dep-fb55187e.js');
require('./_chunks/dep-65b2a290.js');
require('./_chunks/dep-51b8dcc5.js');
require('./_chunks/dep-2c45a7c8.js');
require('./_chunks/dep-edb64bb3.js');
require('./_chunks/dep-216eb455.js');
require('./_chunks/dep-9059ceab.js');
require('./_chunks/dep-e1ee8baa.js');
require('./_chunks/dep-ec417fb3.js');
require('./_chunks/dep-11900ba0.js');
require('./_chunks/dep-68999828.js');
require('./_chunks/dep-8c8ba0a8.js');
require('./_chunks/dep-b99dd3a6.js');
require('./hooks/useClass.js');
require('./_chunks/dep-977081b1.js');
require('./_chunks/dep-90d1f1f6.js');
require('./_common/js/global-config/mobile/default-config.js');
require('./_common/js/global-config/mobile/locale/zh_CN.js');
require('./_chunks/dep-5b94d99d.js');
require('./_chunks/dep-b912c957.js');
require('dayjs');
require('./_chunks/dep-107d4340.js');
require('./_chunks/dep-f8610152.js');
require('./_chunks/dep-95fd413d.js');
require('./_chunks/dep-7ede1657.js');
require('./_chunks/dep-d8a9a6b3.js');
require('./_chunks/dep-4381ced7.js');
require('./_chunks/dep-533c057c.js');
require('./_chunks/dep-87690293.js');
require('./_chunks/dep-b55fb6e4.js');
require('./_chunks/dep-e11b336c.js');
require('./_chunks/dep-99f0ef00.js');
require('./_chunks/dep-160a3aa4.js');
require('./button/button.js');
require('./button/props.js');
require('./form/hooks.js');
require('./_chunks/dep-fc7a09a0.js');
require('./shared/hover.js');
require('./loading/loading.js');
require('./loading/icon/gradient.js');
require('./_common/js/loading/circle-adapter.js');
require('./_common/js/utils/setStyle.js');
require('./_common/js/utils/helper.js');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('./_chunks/dep-1f68b3d8.js');
require('./_chunks/dep-01f34845.js');
require('./_chunks/dep-619e29e1.js');
require('./loading/icon/spinner.js');
require('./loading/props.js');
require('./shared/dom.js');
require('./shared/component.js');
require('./popup/popup.js');
require('./popup/props.js');
require('./hooks/useVModel.js');
require('./hooks/useLockScroll.js');
require('./_util/useTouch.js');
require('./_util/getScrollParent.js');
require('./hooks/useTeleport.js');
require('./shared/render-tnode.js');
require('./overlay/overlay.js');
require('./overlay/props.js');
require('./shared/util.js');
require('./message/message.js');
require('./message/props.js');
require('./link/link.js');
require('./link/props.js');
require('./toast/toast.js');
require('./toast/props.js');
require('./drawer/drawer.js');
require('./drawer/props.js');
require('./action-sheet/action-sheet.js');
require('./action-sheet/action-sheet-grid.js');
require('./grid/grid.js');
require('./grid/props.js');
require('./grid/grid-item.js');
require('./grid/grid-item-props.js');
require('./image/image.js');
require('@vueuse/core');
require('./image/props.js');
require('./badge/badge.js');
require('./badge/props.js');
require('./swiper/swiper.js');
require('./swipe-cell/useSwipe.js');
require('./swiper/props.js');
require('./swiper/swiper-item.js');
require('./action-sheet/action-sheet-list.js');
require('./action-sheet/props.js');
require('./divider/divider.js');
require('./divider/props.js');
require('./fab/fab.js');
require('./fab/props.js');
require('./layout/row.js');
require('./layout/row-props.js');
require('./layout/constants.js');
require('./layout/col.js');
require('./layout/col-props.js');
require('./back-top/back-top.js');
require('./back-top/props.js');
require('./indexes/indexes.js');
require('./indexes/props.js');
require('./_chunks/dep-64d3d4a6.js');
require('./_chunks/dep-8a82bab9.js');
require('./indexes/indexes-anchor.js');
require('./indexes/indexes-anchor-props.js');
require('./navbar/navbar.js');
require('./navbar/props.js');
require('./side-bar/side-bar.js');
require('./side-bar/props.js');
require('./side-bar/side-bar-item.js');
require('./side-bar/side-bar-item-props.js');
require('./steps/steps.js');
require('./steps/props.js');
require('./steps/step-item.js');
require('./steps/step-item-props.js');
require('./tab-bar/tab-bar.js');
require('./tab-bar/props.js');
require('./shared/useChildSlots/index.js');
require('./tab-bar/tab-bar-item.js');
require('./tab-bar/useTabBar.js');
require('./tab-bar/tab-bar-item-props.js');
require('./tabs/tabs.js');
require('./tabs/props.js');
require('./tabs/tab-nav-item.js');
require('./tabs/tab-panel-props.js');
require('./shared/constants.js');
require('./sticky/sticky.js');
require('./sticky/props.js');
require('./tabs/tab-panel.js');
require('./calendar/calendar.js');
require('./calendar/props.js');
require('./calendar/template.js');
require('./calendar/template-props.js');
require('./calendar/utils.js');
require('./cascader/cascader.js');
require('./cascader/props.js');
require('./radio/radio.js');
require('./radio/props.js');
require('./radio/radio-group.js');
require('./radio/radio-group-props.js');
require('./checkbox/checkbox.js');
require('./checkbox/props.js');
require('./checkbox/checkbox-group.js');
require('./checkbox/checkbox-group-props.js');
require('./checkbox/hooks/getOptions.js');
require('./checkbox/hooks/setCheckAllStatus.js');
require('./_chunks/dep-22656ba9.js');
require('./color-picker/color-picker.js');
require('./color-picker/props.js');
require('./color-picker/helper.js');
require('./_common/js/color-picker/constants.js');
require('./_common/js/color-picker/color.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('tinycolor2');
require('./_common/js/color-picker/cmyk.js');
require('./_common/js/color-picker/gradient.js');
require('./color-picker/constants.js');
require('./date-time-picker/date-time-picker.js');
require('./_chunks/dep-754eca7e.js');
require('./date-time-picker/props.js');
require('./date-time-picker/shared.js');
require('./picker/picker.js');
require('./picker/props.js');
require('./picker/picker-item.js');
require('./picker/picker.class.js');
require('./picker/utils.js');
require('./picker/cascade.js');
require('./form/form.js');
require('@babel/runtime/helpers/asyncToGenerator');
require('@babel/runtime/regenerator');
require('./form/props.js');
require('./form/const.js');
require('./shared/render.js');
require('./form/form-item.js');
require('./form/form-model.js');
require('./form/form-item-props.js');
require('./_chunks/dep-cfe645e2.js');
require('./_chunks/dep-423745b7.js');
require('./_chunks/dep-6f174cc2.js');
require('./input/input.js');
require('./input/props.js');
require('./hooks/useLengthLimit.js');
require('./_common/js/log/log.js');
require('./rate/rate.js');
require('./rate/props.js');
require('./search/search.js');
require('./search/props.js');
require('./_common/js/common.js');
require('./cell/cell.js');
require('./cell/props.js');
require('./slider/slider.js');
require('./slider/props.js');
require('./slider/tool.js');
require('./stepper/stepper.js');
require('./stepper/props.js');
require('./switch/switch.js');
require('./switch/props.js');
require('./shared/useToggle/index.js');
require('./textarea/textarea.js');
require('./textarea/props.js');
require('./_common/js/utils/calcTextareaHeight.js');
require('./tree-select/tree-select.js');
require('./tree-select/props.js');
require('./upload/upload.js');
require('./upload/props.js');
require('./upload/hooks/useUpload.js');
require('./_common/js/upload/main.js');
require('@babel/runtime/helpers/toArray');
require('./_common/js/upload/utils.js');
require('./_common/js/upload/xhr.js');
require('./image-viewer/image-viewer.js');
require('./image-viewer/props.js');
require('./hooks/useDefaultValue.js');
require('./shared/useGesture/index.js');
require('@use-gesture/vanilla');
require('./avatar/avatar.js');
require('./avatar/props.js');
require('./_common/js/avatar/utils.js');
require('./avatar/avatar-group.js');
require('./avatar/avatar-group-props.js');
require('./cell/cell-group.js');
require('./cell/cell-group-props.js');
require('./collapse/collapse.js');
require('./collapse/props.js');
require('./collapse/collapse-panel.js');
require('./collapse/collapse-panel-props.js');
require('./collapse/util.js');
require('./count-down/count-down.js');
require('./count-down/props.js');
require('./shared/useCountDown/index.js');
require('./shared/useCountDown/utils.js');
require('./empty/empty.js');
require('./empty/props.js');
require('./footer/footer.js');
require('./footer/props.js');
require('./list/list.js');
require('./list/props.js');
require('./shared/useScrollParent/index.js');
require('./progress/progress.js');
require('./progress/utils.js');
require('./progress/props.js');
require('./_common/js/progress/const.js');
require('./_common/js/progress/utils.js');
require('./result/result.js');
require('./result/props.js');
require('./hooks/icon.js');
require('./skeleton/skeleton.js');
require('./skeleton/props.js');
require('./table/base-table.js');
require('./table/base-table-props.js');
require('./table/hooks/useClassName.js');
require('./table/hooks/useStyle.js');
require('./tag/tag.js');
require('./tag/props.js');
require('./tag/check-tag.js');
require('./tag/check-tag-props.js');
require('./dropdown-menu/dropdown-menu.js');
require('./dropdown-menu/context.js');
require('./dropdown-menu/dom-utils.js');
require('./dropdown-menu/props.js');
require('./shared/useExpose/index.js');
require('./dropdown-menu/dropdown-item.js');
require('./dropdown-menu/dropdown-item-props.js');
require('./guide/guide.js');
require('./guide/props.js');
require('./guide/utils/dom.js');
require('./popover/popover.js');
require('./popover/props.js');
require('./shared/useClickAway/index.js');
require('./notice-bar/notice-bar.js');
require('./notice-bar/props.js');
require('./pull-down-refresh/pull-down-refresh.js');
require('./pull-down-refresh/props.js');
require('./pull-down-refresh/useTouch.js');
require('./swipe-cell/swipe-cell.js');
require('./swipe-cell/props.js');
require('./swipe-cell/useSureConfirm.js');
require('./config-provider/config-provider.js');
require('./config-provider/props.js');

var install = function install(app, option) {
  Object.keys(components.components).forEach(function (key) {
    app.use(components.components[key], option);
  });
};
var version = "1.9.0";
var tdesign = {
  install: install,
  version: version
};

exports.Dialog = dialog_index.DialogPlugin;
exports.DialogPlugin = dialog_index.DialogPlugin;
exports.Message = message_index.MessagePlugin;
exports.MessagePlugin = message_index.MessagePlugin;
exports.Toast = toast_plugin.ToastPlugin;
exports.ToastPlugin = toast_plugin.ToastPlugin;
exports.DrawerPlugin = drawer_plugin["default"];
exports.LoadingPlugin = loading_plugin.LoadingPlugin;
exports.ActionSheet = actionSheet_index._ActionSheet;
exports._ActionSheet = actionSheet_index._ActionSheet;
exports.Button = button_index.Button;
exports.Divider = divider_index.Divider;
exports.Fab = fab_index.Fab;
exports.Icon = icon_index.Icon;
exports.Col = layout_index.Col;
exports.Row = layout_index.Row;
exports.Link = link_index.Link;
exports.BackTop = backTop_index.BackTop;
exports.Drawer = drawer_index.Drawer;
exports.Indexes = indexes_index.Indexes;
exports.IndexesAnchor = indexes_index.IndexesAnchor;
exports.Navbar = navbar_index.Navbar;
exports.SideBar = sideBar_index.SideBar;
exports.SideBarItem = sideBar_index.SideBarItem;
exports.StepItem = steps_index.StepItem;
exports.Steps = steps_index.Steps;
exports.TabBar = tabBar_index.TabBar;
exports.TabBarItem = tabBar_index.TabBarItem;
exports.TabPanel = tabs_index.TabPanel;
exports.Tabs = tabs_index.Tabs;
exports.Calendar = calendar_index.Calendar;
exports.Cascader = cascader_index.Cascader;
exports.Checkbox = checkbox_index.Checkbox;
exports.CheckboxGroup = checkbox_index.CheckboxGroup;
exports.ColorPicker = colorPicker_index.ColorPicker;
exports.DateTimePicker = dateTimePicker_index.DateTimePicker;
exports.Form = form_index.Form;
exports.FormItem = form_index.FormItem;
exports.Input = input_index.Input;
exports.Cascade = picker_index.Cascade;
exports.Picker = picker_index.Picker;
exports.Radio = radio_index.Radio;
exports.RadioGroup = radio_index.RadioGroup;
exports.Rate = rate_index.Rate;
exports.Search = search_index.Search;
exports.Slider = slider_index.Slider;
exports.Stepper = stepper_index.Stepper;
exports.Switch = switch_index.Switch;
exports.Textarea = textarea_index.Textarea;
exports.TreeSelect = treeSelect_index.TreeSelect;
exports.Upload = upload_index.Upload;
exports.Avatar = avatar_index.Avatar;
exports.AvatarGroup = avatar_index.AvatarGroup;
exports.Badge = badge_index.Badge;
exports.Cell = cell_index.Cell;
exports.CellGroup = cell_index.CellGroup;
exports.Collapse = collapse_index.Collapse;
exports.CollapsePanel = collapse_index.CollapsePanel;
exports.CountDown = countDown_index.CountDown;
exports.Empty = empty_index.Empty;
exports.Footer = footer_index.Footer;
exports.Grid = grid_index.Grid;
exports.GridItem = grid_index.GridItem;
exports.Image = image_index.Image;
exports.ImageViewer = imageViewer_index.ImageViewer;
exports.List = list_index.List;
exports.Progress = progress_index.Progress;
exports.Result = result_index.Result;
exports.Skeleton = skeleton_index.Skeleton;
exports.Sticky = sticky_index.Sticky;
exports.Swiper = swiper_index.Swiper;
exports.SwiperItem = swiper_index.SwiperItem;
exports.Table = table_index.Table;
exports.CheckTag = tag_index.CheckTag;
exports.Tag = tag_index.Tag;
exports.DropdownItem = dropdownMenu_index.DropdownItem;
exports.DropdownMenu = dropdownMenu_index.DropdownMenu;
exports.Guide = guide_index.Guide;
exports.Loading = loading_index.Loading;
exports.NoticeBar = noticeBar_index.NoticeBar;
exports.Overlay = overlay_index.Overlay;
exports.Popover = popover_index.Popover;
exports.Popup = popup_index.Popup;
exports.PullDownRefresh = pullDownRefresh_index.PullDownRefresh;
exports.SwipeCell = swipeCell_index.SwipeCell;
exports.ConfigProvider = configProvider_index.ConfigProvider;
exports["default"] = tdesign;
exports.install = install;
exports.version = version;
//# sourceMappingURL=index.js.map
