/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var config = require('../config.js');
var indexes_indexesAnchorProps = require('./indexes-anchor-props.js');
var hooks_useClass = require('../hooks/useClass.js');
var hooks_tnode = require('../hooks/tnode.js');
require('../_chunks/dep-977081b1.js');
require('@babel/runtime/helpers/defineProperty');
require('../_chunks/dep-90d1f1f6.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-5b94d99d.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-b912c957.js');
require('dayjs');
require('../_chunks/dep-107d4340.js');
require('../_chunks/dep-f8610152.js');
require('../_chunks/dep-95fd413d.js');
require('../_chunks/dep-b99dd3a6.js');
require('../_chunks/dep-9059ceab.js');
require('../_chunks/dep-a9c0c920.js');
require('../_chunks/dep-48b1ccc0.js');
require('../_chunks/dep-7ede1657.js');
require('../_chunks/dep-11900ba0.js');
require('../_chunks/dep-b1b7627b.js');
require('../_chunks/dep-68999828.js');
require('../_chunks/dep-8c8ba0a8.js');
require('../_chunks/dep-161c0305.js');
require('../_chunks/dep-d8a9a6b3.js');
require('../_chunks/dep-4381ced7.js');
require('../_chunks/dep-533c057c.js');
require('../_chunks/dep-87690293.js');
require('../_chunks/dep-b55fb6e4.js');
require('../_chunks/dep-e11b336c.js');
require('../_chunks/dep-ec417fb3.js');
require('../_chunks/dep-51f8b65c.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-cc4bd331.js');
require('../_chunks/dep-fb55187e.js');
require('../_chunks/dep-65b2a290.js');
require('../_chunks/dep-51b8dcc5.js');
require('../_chunks/dep-2c45a7c8.js');
require('../_chunks/dep-edb64bb3.js');
require('../_chunks/dep-216eb455.js');
require('../_chunks/dep-e1ee8baa.js');

var prefix = config["default"].prefix;
var _IndexesAnchor = vue.defineComponent({
  name: "".concat(prefix, "-indexes-anchor"),
  props: indexes_indexesAnchorProps["default"],
  setup: function setup(props) {
    var readerTNodeJSX = hooks_tnode.useTNodeJSX();
    var indexesAnchorClass = hooks_useClass.usePrefixClass("indexes-anchor");
    var instance = vue.getCurrentInstance();
    var indexesProvide = vue.inject("indexesProvide", void 0);
    var proxy = instance.proxy;
    indexesProvide.relation(proxy);
    return function () {
      return vue.createVNode("div", {
        "class": indexesAnchorClass.value,
        "data-index": props.index
      }, [vue.createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__wrapper")
      }, [vue.createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__slot")
      }, [readerTNodeJSX("default")]), vue.createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__header")
      }, [props.index])])]);
    };
  }
});

exports["default"] = _IndexesAnchor;
//# sourceMappingURL=indexes-anchor.js.map
