/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var _common_js_loading_circleAdapter = require('../../_common/js/loading/circle-adapter.js');
var config = require('../../config.js');
var hooks_useClass = require('../../hooks/useClass.js');
require('@babel/runtime/helpers/defineProperty');
require('../../_common/js/utils/setStyle.js');
require('../../_common/js/utils/helper.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/objectWithoutProperties');
require('@babel/runtime/helpers/slicedToArray');
require('../../_chunks/dep-1f68b3d8.js');
require('../../_chunks/dep-01f34845.js');
require('../../_chunks/dep-51f8b65c.js');
require('../../_chunks/dep-a9c0c920.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-161c0305.js');
require('../../_chunks/dep-b1b7627b.js');
require('../../_chunks/dep-619e29e1.js');
require('../../_chunks/dep-977081b1.js');
require('../../_chunks/dep-90d1f1f6.js');
require('../../_common/js/global-config/mobile/default-config.js');
require('../../_common/js/global-config/mobile/locale/zh_CN.js');
require('../../_chunks/dep-5b94d99d.js');
require('../../_chunks/dep-b912c957.js');
require('dayjs');
require('../../_chunks/dep-107d4340.js');
require('../../_chunks/dep-f8610152.js');
require('../../_chunks/dep-95fd413d.js');
require('../../_chunks/dep-b99dd3a6.js');
require('../../_chunks/dep-9059ceab.js');
require('../../_chunks/dep-48b1ccc0.js');
require('../../_chunks/dep-7ede1657.js');
require('../../_chunks/dep-11900ba0.js');
require('../../_chunks/dep-68999828.js');
require('../../_chunks/dep-8c8ba0a8.js');
require('../../_chunks/dep-d8a9a6b3.js');
require('../../_chunks/dep-4381ced7.js');
require('../../_chunks/dep-533c057c.js');
require('../../_chunks/dep-87690293.js');
require('../../_chunks/dep-b55fb6e4.js');
require('../../_chunks/dep-e11b336c.js');
require('../../_chunks/dep-ec417fb3.js');

var prefix = config["default"].prefix;
var TGradientIcon = vue.defineComponent({
  name: "".concat(prefix, "-gradient"),
  props: {
    style: Object
  },
  setup: function setup(props) {
    var gradientClass = hooks_useClass.usePrefixClass("loading__gradient");
    var classes = [gradientClass.value, "".concat(prefix, "-icon-loading")];
    var circle = vue.ref();
    var updateColor = function updateColor() {
      var circleElem = circle.value;
      _common_js_loading_circleAdapter["default"](circleElem);
    };
    vue.onMounted(function () {
      vue.nextTick(function () {
        updateColor();
      });
    });
    vue.onUpdated(function () {
      updateColor();
    });
    return function () {
      return vue.createVNode("svg", {
        "style": props.style,
        "class": classes,
        "viewBox": "0 0 12 12",
        "version": "1.1",
        "width": "1em",
        "height": "1em",
        "xmlns": "http://www.w3.org/2000/svg"
      }, [vue.createVNode("foreignObject", {
        "x": "0",
        "y": "0",
        "width": "12",
        "height": "12"
      }, [vue.createVNode("div", {
        "ref": circle,
        "class": "".concat(gradientClass.value, "-conic")
      }, null)])]);
    };
  }
});

exports["default"] = TGradientIcon;
//# sourceMappingURL=gradient.js.map
