/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var vue = require('vue');
var config = require('../config.js');
var picker_props = require('./props.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_tnode = require('../hooks/tnode.js');
var picker_pickerItem = require('./picker-item.js');
var picker_utils = require('./utils.js');
var hooks_useClass = require('../hooks/useClass.js');
var configProvider_useConfig = require('../_chunks/dep-977081b1.js');
var isFunction = require('../_chunks/dep-9059ceab.js');
var get = require('../_chunks/dep-99f0ef00.js');
var isString = require('../_chunks/dep-51f8b65c.js');
var isBoolean = require('../_chunks/dep-fc7a09a0.js');
require('../_chunks/dep-216eb455.js');
require('../_chunks/dep-edb64bb3.js');
require('../_chunks/dep-fb55187e.js');
require('../_chunks/dep-a9c0c920.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-65b2a290.js');
require('../_chunks/dep-161c0305.js');
require('../_chunks/dep-51b8dcc5.js');
require('../_chunks/dep-b1b7627b.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-48b1ccc0.js');
require('../_chunks/dep-cc4bd331.js');
require('../_chunks/dep-2c45a7c8.js');
require('../_chunks/dep-e1ee8baa.js');
require('../_chunks/dep-ec417fb3.js');
require('../_chunks/dep-11900ba0.js');
require('../_chunks/dep-68999828.js');
require('../_chunks/dep-8c8ba0a8.js');
require('../_chunks/dep-b99dd3a6.js');
require('./picker.class.js');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('../shared/dom.js');
require('../_chunks/dep-90d1f1f6.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-5b94d99d.js');
require('../_chunks/dep-b912c957.js');
require('dayjs');
require('../_chunks/dep-107d4340.js');
require('../_chunks/dep-f8610152.js');
require('../_chunks/dep-95fd413d.js');
require('../_chunks/dep-7ede1657.js');
require('../_chunks/dep-d8a9a6b3.js');
require('../_chunks/dep-4381ced7.js');
require('../_chunks/dep-533c057c.js');
require('../_chunks/dep-87690293.js');
require('../_chunks/dep-b55fb6e4.js');
require('../_chunks/dep-e11b336c.js');
require('../_chunks/dep-160a3aa4.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var prefix = config["default"].prefix;
var getIndexFromColumns = function getIndexFromColumns(column, value, keys) {
  if (!value) return 0;
  return column === null || column === void 0 ? void 0 : column.findIndex(function (item) {
    var _keys$value;
    return get.get(item, (_keys$value = keys === null || keys === void 0 ? void 0 : keys.value) !== null && _keys$value !== void 0 ? _keys$value : "value") === value;
  });
};
var _Picker = vue.defineComponent({
  name: "".concat(prefix, "-picker"),
  components: {
    PickerItem: picker_pickerItem["default"]
  },
  props: picker_props["default"],
  emits: ["change", "cancel", "pick", "update:modelValue", "update:value"],
  setup: function setup(props, _ref) {
    var _pickerValue$value;
    var slots = _ref.slots;
    var pickerClass = hooks_useClass.usePrefixClass("picker");
    var _useConfig = configProvider_useConfig.useConfig("picker"),
      globalConfig = _useConfig.globalConfig;
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var _toRefs = vue.toRefs(props),
      value = _toRefs.value,
      modelValue = _toRefs.modelValue;
    var _useVModel = hooks_useVModel["default"](value, modelValue, props.defaultValue, props.onChange),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      _useVModel2$ = _useVModel2[0],
      pickerValue = _useVModel2$ === void 0 ? vue.ref([]) : _useVModel2$,
      setPickerValue = _useVModel2[1];
    var keys = vue.computed(function () {
      return props.keys;
    });
    var getDefaultText = function getDefaultText(prop, defaultText) {
      if (isString.isString(prop)) return prop;
      if (isBoolean.isBoolean(prop) && prop) return defaultText;
      return "";
    };
    var confirmButtonText = vue.computed(function () {
      return getDefaultText(props.confirmBtn, globalConfig.value.confirm);
    });
    var cancelButtonText = vue.computed(function () {
      return getDefaultText(props.cancelBtn, globalConfig.value.cancel);
    });
    var curValueArray = vue.ref(((_pickerValue$value = pickerValue.value) === null || _pickerValue$value === void 0 ? void 0 : _pickerValue$value.map(function (item) {
      return item;
    })) || []);
    var realColumns = vue.computed(function () {
      if (isFunction.isFunction(props.columns)) {
        var _columns = props.columns(curValueArray.value);
        return picker_utils.getPickerColumns(_columns);
      }
      return picker_utils.getPickerColumns(props.columns);
    });
    var curIndexArray = realColumns.value.map(function (item, index) {
      var _pickerValue$value2;
      return getIndexFromColumns(item, (_pickerValue$value2 = pickerValue.value) === null || _pickerValue$value2 === void 0 ? void 0 : _pickerValue$value2[index], keys.value);
    });
    var pickerItemInstanceArray = vue.ref([]);
    var setPickerItemRef = function setPickerItemRef(item, index) {
      pickerItemInstanceArray.value[index] = item;
    };
    var handleConfirm = function handleConfirm(e) {
      var _props$onConfirm;
      var target = realColumns.value.map(function (item, index) {
        return item[curIndexArray[index]];
      });
      var label = target.map(function (item) {
        var _keys$value$label, _keys$value2;
        return get.get(item, (_keys$value$label = (_keys$value2 = keys.value) === null || _keys$value2 === void 0 ? void 0 : _keys$value2.label) !== null && _keys$value$label !== void 0 ? _keys$value$label : "label");
      });
      var value2 = target.map(function (item) {
        var _keys$value$value, _keys$value3;
        return get.get(item, (_keys$value$value = (_keys$value3 = keys.value) === null || _keys$value3 === void 0 ? void 0 : _keys$value3.value) !== null && _keys$value$value !== void 0 ? _keys$value$value : "value");
      });
      setPickerValue(value2);
      (_props$onConfirm = props.onConfirm) === null || _props$onConfirm === void 0 || _props$onConfirm.call(props, value2, {
        index: curIndexArray,
        label: label,
        e: e
      });
    };
    var handleCancel = function handleCancel(e) {
      var _props$onCancel;
      pickerItemInstanceArray.value.forEach(function (item, index) {
        item === null || item === void 0 || item.setIndex(curIndexArray[index]);
      });
      (_props$onCancel = props.onCancel) === null || _props$onCancel === void 0 || _props$onCancel.call(props, {
        e: e
      });
    };
    var handlePick = function handlePick(context, column) {
      var _realColumns$value, _keys$value$value2, _keys$value4, _props$onPick;
      var index = context.index;
      curIndexArray[column] = index;
      curValueArray.value[column] = get.get((_realColumns$value = realColumns.value) === null || _realColumns$value === void 0 ? void 0 : _realColumns$value[column][index], (_keys$value$value2 = (_keys$value4 = keys.value) === null || _keys$value4 === void 0 ? void 0 : _keys$value4.value) !== null && _keys$value$value2 !== void 0 ? _keys$value$value2 : "value");
      (_props$onPick = props.onPick) === null || _props$onPick === void 0 || _props$onPick.call(props, curValueArray.value, {
        index: index,
        column: column
      });
    };
    vue.watch(pickerValue, function () {
      curValueArray.value = pickerValue.value.map(function (item) {
        return item;
      });
    });
    vue.watch([realColumns, curValueArray], function () {
      realColumns.value.forEach(function (col, idx) {
        var _pickerItemInstanceAr;
        var index = col.findIndex(function (item) {
          var _keys$value$value3, _keys$value5;
          return get.get(item, (_keys$value$value3 = (_keys$value5 = keys.value) === null || _keys$value5 === void 0 ? void 0 : _keys$value5.value) !== null && _keys$value$value3 !== void 0 ? _keys$value$value3 : "value") === curValueArray.value[idx];
        });
        curIndexArray[idx] = index > -1 ? index : 0;
        (_pickerItemInstanceAr = pickerItemInstanceArray.value[idx]) === null || _pickerItemInstanceAr === void 0 || _pickerItemInstanceAr.setIndex(curIndexArray[idx]);
      });
    });
    vue.provide("picker", _objectSpread({}, vue.toRefs(props)));
    return function () {
      return vue.createVNode("div", {
        "class": "".concat(pickerClass.value)
      }, [vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__toolbar")
      }, [cancelButtonText.value && vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__cancel"),
        "onClick": handleCancel
      }, [cancelButtonText.value]), vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__title")
      }, [props.title]), confirmButtonText.value && vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__confirm"),
        "onClick": handleConfirm
      }, [confirmButtonText.value])]), renderTNodeJSX("header"), vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__main")
      }, [realColumns.value.map(function (item, index) {
        var _pickerValue$value3;
        return vue.createVNode("div", {
          "key": index,
          "class": "".concat(pickerClass.value, "-item__group")
        }, [vue.createVNode(vue.resolveComponent("picker-item"), {
          "ref": function ref(item2) {
            return setPickerItemRef(item2, index);
          },
          "options": item,
          "value": (_pickerValue$value3 = pickerValue.value) === null || _pickerValue$value3 === void 0 ? void 0 : _pickerValue$value3[index],
          "render-label": props.renderLabel,
          "onPick": function onPick($event) {
            return handlePick($event, index);
          },
          "swipeDuration": props.swipeDuration
        }, {
          option: slots.option || props.option
        })]);
      }), vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__mask ").concat(pickerClass.value, "__mask--top")
      }, null), vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__mask ").concat(pickerClass.value, "__mask--bottom")
      }, null), vue.createVNode("div", {
        "class": "".concat(pickerClass.value, "__indicator")
      }, null)]), renderTNodeJSX("footer")]);
    };
  }
});

exports["default"] = _Picker;
//# sourceMappingURL=picker.js.map
