/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var isArray = require('../_chunks/dep-161c0305.js');
var get = require('../_chunks/dep-99f0ef00.js');
require('../_chunks/dep-160a3aa4.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-51b8dcc5.js');
require('../_chunks/dep-a9c0c920.js');
require('../_chunks/dep-b1b7627b.js');
require('../_chunks/dep-4381ced7.js');
require('../_chunks/dep-b99dd3a6.js');
require('../_chunks/dep-9059ceab.js');
require('../_chunks/dep-48b1ccc0.js');
require('../_chunks/dep-7ede1657.js');
require('../_chunks/dep-fb55187e.js');
require('../_chunks/dep-65b2a290.js');

var isMultipleArray = function isMultipleArray(arr) {
  return isArray.isArray(arr[0]);
};
var getPickerColumns = function getPickerColumns(columns) {
  return isMultipleArray(columns) ? columns : [columns];
};
var limitNumberInRange = function limitNumberInRange(num, min, max) {
  return Math.min(Math.max(num, min), max);
};
function findIndexOfEnabledOption(options, startIndex, keys) {
  var limitStartIndex = limitNumberInRange(startIndex, 0, options.length - 1);
  var forwardIndex = options.findIndex(function (opt, idx) {
    var _keys$disabled;
    return !get.get(opt, (_keys$disabled = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled !== void 0 ? _keys$disabled : "disabled") && idx >= limitStartIndex;
  });
  if (forwardIndex !== -1) {
    return forwardIndex;
  }
  var backwardIndex = options.slice(0, limitStartIndex).reverse().findIndex(function (opt) {
    var _keys$disabled2;
    return !get.get(opt, (_keys$disabled2 = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled2 !== void 0 ? _keys$disabled2 : "disabled");
  });
  if (backwardIndex !== -1) {
    return limitStartIndex - 1 - backwardIndex;
  }
  return 0;
}

exports.findIndexOfEnabledOption = findIndexOfEnabledOption;
exports.getPickerColumns = getPickerColumns;
exports.isMultipleArray = isMultipleArray;
exports.limitNumberInRange = limitNumberInRange;
//# sourceMappingURL=utils.js.map
