/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');

var withInstall = function withInstall(comp, alias) {
  var c = comp;
  c.install = function (app, name) {
    var defaultName = c.name;
    app.component(alias || name || defaultName, comp);
  };
  return c;
};
function extendAPI(apis) {
  var instance = vue.getCurrentInstance();
  if (instance && instance.proxy) {
    Object.assign(instance.proxy, apis);
  }
}

exports["default"] = withInstall;
exports.extendAPI = extendAPI;
exports.withInstall = withInstall;
//# sourceMappingURL=component.js.map
