/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var Hover = {
  created: function created(el, binding) {
    var startTime = 50;
    var stayTime = 70;
    var _binding$value = binding.value,
      className = _binding$value.className,
      _binding$value$disabl = _binding$value.disabledHover,
      disabledHover = _binding$value$disabl === void 0 ? false : _binding$value$disabl;
    el.addEventListener("touchstart", function () {
      if (disabledHover) return;
      setTimeout(function () {
        el === null || el === void 0 || el.classList.add(className);
      }, startTime);
    }, {
      capture: false,
      passive: true
    });
    el.addEventListener("touchend", function () {
      if (disabledHover) return;
      setTimeout(function () {
        el === null || el === void 0 || el.classList.remove(className);
      }, stayTime);
    }, false);
  }
};

exports["default"] = Hover;
//# sourceMappingURL=hover.js.map
