/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');

function useToggle(values, defaultValue) {
  var innerValues = values || [true, false];
  var state = vue.ref();
  if (defaultValue === void 0) {
    state = vue.ref(innerValues[1]);
  } else if (vue.isRef(defaultValue)) {
    state = defaultValue;
  } else {
    state = vue.ref(defaultValue);
  }
  var toggle = function toggle(value) {
    if (value !== void 0) {
      state.value = value;
    } else {
      state.value = state.value === innerValues[1] ? innerValues[0] : innerValues[1];
    }
  };
  return {
    state: state,
    toggle: toggle
  };
}

exports.useToggle = useToggle;
//# sourceMappingURL=index.js.map
