/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var config = require('../config.js');
var isNumber = require('../_chunks/dep-619e29e1.js');
require('../_chunks/dep-a9c0c920.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-b1b7627b.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

var prefix = config["default"].prefix;
function toCamel(str) {
  return str.replace(/^\S/, function (m) {
    return m.toUpperCase();
  });
}
var isBrowser = typeof window !== "undefined";
var sleep = function sleep(ms) {
  return new Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};
var uniqueFactory = function uniqueFactory(compName) {
  var number = 0;
  return function () {
    return "".concat(prefix, "-").concat(compName, "_").concat(number++);
  };
};
var convertUnit = function convertUnit(val) {
  if (val == null) return 0;
  return isNumber.isNumber(val) ? "".concat(val, "px") : val;
};
var reconvertUnit = function reconvertUnit(val) {
  if (val == null) return 0;
  return isNumber.isNumber(val) ? Number(val) : Number(val.slice(0, -2));
};
var formatNumber = function formatNumber(value) {
  var allowDecimal = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var allowNegative = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  if (allowDecimal) {
    var index = value.indexOf(".");
    if (index !== -1) {
      value = "".concat(value.slice(0, index + 1)).concat(value.slice(index).replace(/\./g, ""));
    }
  } else {
    var _value$split = value.split("."),
      _value$split2 = _slicedToArray__default["default"](_value$split, 1),
      _value$split2$ = _value$split2[0],
      splitValue = _value$split2$ === void 0 ? "" : _value$split2$;
    value = splitValue;
  }
  if (allowNegative) {
    var _index = value.indexOf("-");
    if (_index !== -1) {
      value = "".concat(value.slice(0, _index + 1)).concat(value.slice(_index).replace(/-/g, ""));
    }
  } else {
    value = value.replace(/-/g, "");
  }
  return value.replace(/[^\d.-]/g, "");
};

exports.convertUnit = convertUnit;
exports.formatNumber = formatNumber;
exports.isBrowser = isBrowser;
exports.reconvertUnit = reconvertUnit;
exports.sleep = sleep;
exports.toCamel = toCamel;
exports.uniqueFactory = uniqueFactory;
//# sourceMappingURL=util.js.map
