/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var SkeletonProps = {
  animation: {
    type: String,
    default: "none",
    validator: function validator(val) {
      if (!val) return true;
      return ["gradient", "flashed", "none"].includes(val);
    }
  },
  delay: {
    type: Number,
    default: 0
  },
  loading: {
    type: Boolean,
    default: true
  },
  rowCol: {
    type: Array
  },
  theme: {
    type: String,
    default: "text",
    validator: function validator(val) {
      if (!val) return true;
      return ["avatar", "image", "text", "paragraph"].includes(val);
    }
  }
};

exports["default"] = SkeletonProps;
//# sourceMappingURL=props.js.map
