/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var trimSingleValue = function trimSingleValue(value, min, max) {
  if (value < min) {
    return min;
  }
  if (value > max) {
    return max;
  }
  return value;
};
var trimValue = function trimValue(value, props) {
  var min = props.min,
    max = props.max,
    range = props.range;
  if (range && Array.isArray(value)) {
    value[0] = trimSingleValue(value[0], min, max);
    value[1] = trimSingleValue(value[1], min, max);
    return value[0] <= value[1] ? value : [value[1], value[0]];
  }
  if (range) {
    return [min, max];
  }
  return trimSingleValue(value, min, max);
};

exports.trimSingleValue = trimSingleValue;
exports.trimValue = trimValue;
//# sourceMappingURL=tool.js.map
