import { TNode } from '../common';
export interface TdSwipeCellProps {
    content?: string | TNode;
    default?: string | TNode;
    disabled?: boolean;
    left?: Array<SwipeActionItem> | TNode;
    opened?: boolean | Array<boolean>;
    right?: Array<SwipeActionItem> | TNode;
    onChange?: (value: string) => void;
    onClick?: (action: SwipeActionItem, source: SwipeSource) => void;
}
export interface SwipeCellInstanceFunctions {
    showSure?: (sure: string | TNode, onClick?: SwipeActionItem['onClick']) => void;
}
export interface SwipeActionItem {
    text: string;
    className?: string;
    style?: string;
    sure?: string | TNode;
    onClick?: () => void;
    [key: string]: any;
}
export declare type SwipeSource = 'left' | 'right';
