/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var vue = require('vue');
var tabBar_props = require('./props.js');
var config = require('../config.js');
var hooks_useVModel = require('../hooks/useVModel.js');
var hooks_tnode = require('../hooks/tnode.js');
var hooks_useClass = require('../hooks/useClass.js');
var shared_useChildSlots_index = require('../shared/useChildSlots/index.js');
require('../_chunks/dep-216eb455.js');
require('../_chunks/dep-edb64bb3.js');
require('../_chunks/dep-fb55187e.js');
require('../_chunks/dep-a9c0c920.js');
require('@babel/runtime/helpers/typeof');
require('../_chunks/dep-65b2a290.js');
require('../_chunks/dep-161c0305.js');
require('../_chunks/dep-51b8dcc5.js');
require('../_chunks/dep-b1b7627b.js');
require('../hooks/render-tnode.js');
require('../_chunks/dep-48b1ccc0.js');
require('../_chunks/dep-51f8b65c.js');
require('../_chunks/dep-cc4bd331.js');
require('../_chunks/dep-2c45a7c8.js');
require('../_chunks/dep-9059ceab.js');
require('../_chunks/dep-e1ee8baa.js');
require('../_chunks/dep-ec417fb3.js');
require('../_chunks/dep-11900ba0.js');
require('../_chunks/dep-68999828.js');
require('../_chunks/dep-8c8ba0a8.js');
require('../_chunks/dep-b99dd3a6.js');
require('../_chunks/dep-977081b1.js');
require('../_chunks/dep-90d1f1f6.js');
require('../_common/js/global-config/mobile/default-config.js');
require('../_common/js/global-config/mobile/locale/zh_CN.js');
require('../_chunks/dep-5b94d99d.js');
require('../_chunks/dep-b912c957.js');
require('dayjs');
require('../_chunks/dep-107d4340.js');
require('../_chunks/dep-f8610152.js');
require('../_chunks/dep-95fd413d.js');
require('../_chunks/dep-7ede1657.js');
require('../_chunks/dep-d8a9a6b3.js');
require('../_chunks/dep-4381ced7.js');
require('../_chunks/dep-533c057c.js');
require('../_chunks/dep-87690293.js');
require('../_chunks/dep-b55fb6e4.js');
require('../_chunks/dep-e11b336c.js');
require('@babel/runtime/helpers/toConsumableArray');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty__default["default"](e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var prefix = config["default"].prefix;
var _TabBar = vue.defineComponent({
  name: "".concat(prefix, "-tab-bar"),
  props: tabBar_props["default"],
  emits: ["update:value", "update:modelValue", "change"],
  setup: function setup(props, context) {
    var tabBarClass = hooks_useClass.usePrefixClass("tab-bar");
    var renderTNodeJSX = hooks_tnode.useTNodeJSX();
    var _toRefs = vue.toRefs(props),
      value = _toRefs.value,
      modelValue = _toRefs.modelValue;
    var _useVModel = hooks_useVModel["default"](value, modelValue, props.defaultValue, props.onChange),
      _useVModel2 = _slicedToArray__default["default"](_useVModel, 2),
      activeValue = _useVModel2[0],
      setActiveValue = _useVModel2[1];
    var defaultIndex = vue.ref(-1);
    var itemCount = vue.ref(0);
    var updateChild = function updateChild(currentValue) {
      setActiveValue(currentValue);
    };
    var rootClass = vue.computed(function () {
      return ["".concat(tabBarClass.value), _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, "".concat(tabBarClass.value, "--bordered"), props.bordered), "".concat(tabBarClass.value, "--fixed"), props.fixed), "".concat(tabBarClass.value, "--safe"), props.safeAreaInsetBottom), "".concat(tabBarClass.value, "--").concat(props.shape)];
    });
    vue.provide("tab-bar", _objectSpread(_objectSpread({}, vue.toRefs(props)), {}, {
      defaultIndex: defaultIndex,
      activeValue: activeValue,
      itemCount: itemCount,
      updateChild: updateChild
    }));
    var updateItemCount = function updateItemCount(vNodes) {
      if (!vNodes || !Array.isArray(vNodes)) {
        itemCount.value = 0;
        return;
      }
      var childSlots = shared_useChildSlots_index.useChildSlots("".concat(prefix, "-tab-bar-item"), vNodes);
      itemCount.value = childSlots.length;
    };
    return function () {
      var vNodes = context.slots.default ? context.slots.default() : [];
      updateItemCount(vNodes);
      return vue.createVNode("div", {
        "class": rootClass.value,
        "role": "tablist"
      }, [renderTNodeJSX("default")]);
    };
  }
});

exports["default"] = _TabBar;
//# sourceMappingURL=tab-bar.js.map
