/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var vue = require('vue');
var table_hooks_useClassName = require('./useClassName.js');
require('../../hooks/useClass.js');
require('../../_chunks/dep-977081b1.js');
require('../../_chunks/dep-90d1f1f6.js');
require('../../_common/js/global-config/mobile/default-config.js');
require('../../_common/js/global-config/mobile/locale/zh_CN.js');
require('../../_chunks/dep-5b94d99d.js');
require('@babel/runtime/helpers/typeof');
require('../../_chunks/dep-b912c957.js');
require('dayjs');
require('../../_chunks/dep-107d4340.js');
require('../../_chunks/dep-f8610152.js');
require('../../_chunks/dep-95fd413d.js');
require('../../_chunks/dep-b99dd3a6.js');
require('../../_chunks/dep-9059ceab.js');
require('../../_chunks/dep-a9c0c920.js');
require('../../_chunks/dep-48b1ccc0.js');
require('../../_chunks/dep-7ede1657.js');
require('../../_chunks/dep-11900ba0.js');
require('../../_chunks/dep-b1b7627b.js');
require('../../_chunks/dep-68999828.js');
require('../../_chunks/dep-8c8ba0a8.js');
require('../../_chunks/dep-161c0305.js');
require('../../_chunks/dep-d8a9a6b3.js');
require('../../_chunks/dep-4381ced7.js');
require('../../_chunks/dep-533c057c.js');
require('../../_chunks/dep-87690293.js');
require('../../_chunks/dep-b55fb6e4.js');
require('../../_chunks/dep-e11b336c.js');
require('../../_chunks/dep-ec417fb3.js');
require('../../_chunks/dep-51f8b65c.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function formatCSSUnit(unit) {
  if (!unit) return unit;
  return isNaN(Number(unit)) ? unit : "".concat(unit, "px");
}
function useStyle(props) {
  var _toRefs = vue.toRefs(props),
    bordered = _toRefs.bordered,
    stripe = _toRefs.stripe,
    verticalAlign = _toRefs.verticalAlign,
    height = _toRefs.height,
    maxHeight = _toRefs.maxHeight,
    tableContentWidth = _toRefs.tableContentWidth;
  var _useClassName = table_hooks_useClassName["default"](),
    tableBaseClass = _useClassName.tableBaseClass,
    tableAlignClasses = _useClassName.tableAlignClasses;
  var tableClasses = vue.computed(function () {
    return [tableBaseClass.table, [tableAlignClasses[(verticalAlign === null || verticalAlign === void 0 ? void 0 : verticalAlign.value) || "middle"]], _defineProperty__default["default"](_defineProperty__default["default"](_defineProperty__default["default"]({}, tableBaseClass.bordered, bordered === null || bordered === void 0 ? void 0 : bordered.value), tableBaseClass.striped, stripe === null || stripe === void 0 ? void 0 : stripe.value), tableBaseClass.loading, props.loading)];
  });
  var tableContentStyles = vue.computed(function () {
    return {
      height: formatCSSUnit(height === null || height === void 0 ? void 0 : height.value),
      maxHeight: formatCSSUnit(maxHeight === null || maxHeight === void 0 ? void 0 : maxHeight.value)
    };
  });
  var tableElementStyles = vue.computed(function () {
    return {
      width: formatCSSUnit(tableContentWidth === null || tableContentWidth === void 0 ? void 0 : tableContentWidth.value)
    };
  });
  return {
    tableClasses: tableClasses,
    tableElementStyles: tableElementStyles,
    tableContentStyles: tableContentStyles
  };
}

exports["default"] = useStyle;
exports.formatCSSUnit = formatCSSUnit;
//# sourceMappingURL=useStyle.js.map
