/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { ref } from 'vue';
import '../shared/index.mjs';
import { isBrowser } from '../shared/util.mjs';
import '../shared/functions.mjs';
import '../shared/component.mjs';
import '../shared/constants.mjs';
import '../config.mjs';
import '../shared/render.mjs';
import '../_chunks/dep-0f7e0eb1.mjs';
import 'lodash-es';
import '../shared/dom.mjs';
import '../shared/render-tnode.mjs';
import '../shared/useToggle/index.mjs';
import '../shared/useCountDown/index.mjs';
import '../_chunks/dep-ebc76206.mjs';
import '../_chunks/dep-308d506d.mjs';
import '@vueuse/core';
import '../shared/useCountDown/utils.mjs';
import '../_chunks/dep-0a95ce1b.mjs';
import '../_chunks/dep-3a5e8269.mjs';
import '../shared/useChildSlots/index.mjs';
import '../_chunks/dep-af443fd2.mjs';
import '../shared/useTouch/index.mjs';
import '../shared/useScrollParent/index.mjs';
import '../shared/useExpose/index.mjs';
import '../shared/useTest/index.mjs';
import '../_chunks/dep-2822c770.mjs';
import '../shared/useClickAway/index.mjs';
import '../shared/useGesture/index.mjs';
import '@use-gesture/vanilla';
import '../shared/hover.mjs';

var supportsPassive = ref(false);
if (!isBrowser) {
  try {
    var opts = {};
    Object.defineProperty(opts, "passive", {
      get: function get() {
        supportsPassive.value = true;
        return true;
      }
    });
    window.addEventListener("test-passive", null, opts);
  } catch (e) {}
}

export { supportsPassive };
//# sourceMappingURL=supportsPassive.mjs.map
