/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var AvatarGroupProps = {
  cascading: {
    type: String,
    default: "right-up",
    validator: function validator(val) {
      if (!val) return true;
      return ["left-up", "right-up"].includes(val);
    }
  },
  collapseAvatar: {
    type: [String, Function]
  },
  max: {
    type: Number
  },
  shape: {
    type: String,
    validator: function validator(val) {
      if (!val) return true;
      return ["circle", "round"].includes(val);
    }
  },
  size: {
    type: String,
    default: ""
  },
  onCollapsedItemClick: Function
};

export { AvatarGroupProps as default };
//# sourceMappingURL=avatar-group-props.mjs.map
