/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var props = {
  clearable: Boolean,
  enableAlpha: Boolean,
  fixed: Boolean,
  format: {
    type: String,
    default: "RGB",
    validator: function validator(val) {
      if (!val) return true;
      return ["HEX", "HEX8", "RGB", "RGBA", "HSL", "HSLA", "HSV", "HSVA", "CMYK", "CSS"].includes(val);
    }
  },
  swatchColors: {
    type: Array,
    default: void 0
  },
  type: {
    type: String,
    default: "base",
    validator: function validator(val) {
      if (!val) return true;
      return ["base", "multiple"].includes(val);
    }
  },
  value: {
    type: String,
    default: void 0
  },
  modelValue: {
    type: String,
    default: void 0
  },
  defaultValue: {
    type: String,
    default: ""
  },
  onChange: Function,
  onPaletteBarChange: Function
};

export { props as default };
//# sourceMappingURL=props.mjs.map
