/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _defineProperty } from '../_chunks/dep-2822c770.mjs';
import { defineComponent, computed, createVNode } from 'vue';
import config from '../config.mjs';
import DividerProps from './props.mjs';
import { useContent } from '../hooks/tnode.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import '../_chunks/dep-0f7e0eb1.mjs';
import 'lodash-es';
import '../hooks/render-tnode.mjs';
import '../config-provider/useConfig.mjs';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-2a1ce6fa.mjs';
import '../_chunks/dep-308d506d.mjs';
import '../_chunks/dep-057983c9.mjs';
import '../_chunks/dep-735bd654.mjs';
import '../config-provider/type.mjs';

var prefix = config.prefix;
var _Divider = defineComponent({
  name: "".concat(prefix, "-divider"),
  props: DividerProps,
  setup: function setup(props) {
    var renderTNodeContent = useContent();
    var dividerClass = usePrefixClass("divider");
    var dividerClasses = computed(function () {
      return ["".concat(dividerClass.value), "".concat(dividerClass.value, "--").concat(props.layout), "".concat(dividerClass.value, "--").concat(props.align), _defineProperty({}, "".concat(dividerClass.value, "--dashed"), props.dashed)];
    });
    return function () {
      var content = renderTNodeContent("default", "content");
      return createVNode("div", {
        "class": dividerClasses.value,
        "role": "separator"
      }, [createVNode("div", {
        "class": "".concat(dividerClass.value, "__content")
      }, [content])]);
    };
  }
});

export { _Divider as default };
//# sourceMappingURL=divider.mjs.map
