/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, withDirectives, createVNode, resolveDirective } from 'vue';
import { Image } from '../image/index.mjs';
import EmptyProps from './props.mjs';
import config from '../config.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import '../image/image.mjs';
import '../_chunks/dep-0a95ce1b.mjs';
import '../_chunks/dep-3a5e8269.mjs';
import '../_chunks/dep-2822c770.mjs';
import '../_chunks/dep-0f7e0eb1.mjs';
import '@vueuse/core';
import 'tdesign-icons-vue-next';
import '../loading/index.mjs';
import '../loading/loading.mjs';
import '../loading/icon/gradient.mjs';
import '../_common/js/loading/circle-adapter.mjs';
import '../_common/js/utils/setStyle.mjs';
import '../_common/js/utils/helper.mjs';
import '../_chunks/dep-af443fd2.mjs';
import '../_chunks/dep-f875d251.mjs';
import 'lodash-es';
import '../loading/icon/spinner.mjs';
import '../loading/props.mjs';
import '../shared/dom.mjs';
import '../shared/index.mjs';
import '../shared/functions.mjs';
import '../shared/util.mjs';
import '../shared/component.mjs';
import '../shared/constants.mjs';
import '../shared/render.mjs';
import '../shared/render-tnode.mjs';
import '../shared/useToggle/index.mjs';
import '../shared/useCountDown/index.mjs';
import '../_chunks/dep-ebc76206.mjs';
import '../_chunks/dep-308d506d.mjs';
import '../shared/useCountDown/utils.mjs';
import '../shared/useChildSlots/index.mjs';
import '../shared/useTouch/index.mjs';
import '../shared/useScrollParent/index.mjs';
import '../shared/useExpose/index.mjs';
import '../shared/useTest/index.mjs';
import '../shared/useClickAway/index.mjs';
import '../shared/useGesture/index.mjs';
import '@use-gesture/vanilla';
import '../shared/hover.mjs';
import './style/css.mjs';
import '../loading/type.mjs';
import '../loading/plugin.mjs';
import '../hooks/render-tnode.mjs';
import '../config-provider/useConfig.mjs';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-2a1ce6fa.mjs';
import '../_chunks/dep-057983c9.mjs';
import '../_chunks/dep-735bd654.mjs';
import '../config-provider/type.mjs';
import '../image/props.mjs';
import '../image/type.mjs';

var prefix = config.prefix;
var _Empty = defineComponent({
  name: "".concat(prefix, "-empty"),
  props: EmptyProps,
  setup: function setup(props) {
    var renderTNodeJSX = useTNodeJSX();
    var emptyClass = usePrefixClass("empty");
    return function () {
      var action = renderTNodeJSX("action");
      var description = renderTNodeJSX("description");
      var readerThumb = function readerThumb() {
        var image = renderTNodeJSX("image");
        if (image) {
          if (typeof props.image === "string") {
            return withDirectives(createVNode(Image, {
              "src": props.image
            }, null), [[resolveDirective("if"), "typeof image === 'string'"]]);
          }
          return image;
        }
        var icon = renderTNodeJSX("icon");
        if (icon) {
          return createVNode("div", {
            "class": "".concat(emptyClass.value, "__icon")
          }, [icon]);
        }
        return null;
      };
      return createVNode("div", {
        "class": emptyClass.value
      }, [createVNode("div", {
        "class": "".concat(emptyClass.value, "__thumb")
      }, [readerThumb()]), description && createVNode("div", {
        "class": "".concat(emptyClass.value, "__description")
      }, [description]), action && createVNode("div", {
        "class": "".concat(emptyClass.value, "__actions")
      }, [action])]);
    };
  }
});

export { _Empty as default };
//# sourceMappingURL=empty.mjs.map
