/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var props = {
  arrow: Boolean,
  contentAlign: {
    type: String,
    default: "left",
    validator: function validator(val) {
      if (!val) return true;
      return ["left", "right"].includes(val);
    }
  },
  for: {
    type: String,
    default: ""
  },
  help: {
    type: [String, Function]
  },
  label: {
    type: [String, Function],
    default: ""
  },
  labelAlign: {
    type: String,
    validator: function validator(val) {
      if (!val) return true;
      return ["left", "right", "top"].includes(val);
    }
  },
  labelWidth: {
    type: [String, Number]
  },
  name: {
    type: [String, Number]
  },
  requiredMark: {
    type: Boolean,
    default: void 0
  },
  rules: {
    type: Array
  },
  showErrorMessage: {
    type: Boolean,
    default: void 0
  }
};

export { props as default };
//# sourceMappingURL=form-item-props.mjs.map
