/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, getCurrentInstance, inject, createVNode } from 'vue';
import config from '../config.mjs';
import indexesAnchorProps from './indexes-anchor-props.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import '../config-provider/useConfig.mjs';
import '../_chunks/dep-2822c770.mjs';
import '../_chunks/dep-0f7e0eb1.mjs';
import 'lodash-es';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-2a1ce6fa.mjs';
import '../_chunks/dep-308d506d.mjs';
import '../_chunks/dep-057983c9.mjs';
import '../_chunks/dep-735bd654.mjs';
import '../config-provider/type.mjs';
import '../hooks/render-tnode.mjs';

var prefix = config.prefix;
var _IndexesAnchor = defineComponent({
  name: "".concat(prefix, "-indexes-anchor"),
  props: indexesAnchorProps,
  setup: function setup(props) {
    var readerTNodeJSX = useTNodeJSX();
    var indexesAnchorClass = usePrefixClass("indexes-anchor");
    var instance = getCurrentInstance();
    var indexesProvide = inject("indexesProvide", void 0);
    var proxy = instance.proxy;
    indexesProvide.relation(proxy);
    return function () {
      return createVNode("div", {
        "class": indexesAnchorClass.value,
        "data-index": props.index
      }, [createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__wrapper")
      }, [createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__slot")
      }, [readerTNodeJSX("default")]), createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__header")
      }, [props.index])])]);
    };
  }
});

export { _IndexesAnchor as default };
//# sourceMappingURL=indexes-anchor.mjs.map
