import { TdInputProps } from './type';
import { PropType } from 'vue';
declare const _default: {
    align: {
        type: PropType<"left" | "center" | "right">;
        default: "left" | "center" | "right";
        validator(val: TdInputProps['align']): boolean;
    };
    allowInputOverMax: BooleanConstructor;
    autocomplete: {
        type: StringConstructor;
        default: any;
    };
    autofocus: BooleanConstructor;
    borderless: BooleanConstructor;
    clearTrigger: {
        type: PropType<"always" | "focus">;
        default: "always" | "focus";
        validator(val: TdInputProps['clearTrigger']): boolean;
    };
    clearable: BooleanConstructor;
    cursorColor: {
        type: StringConstructor;
        default: string;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    enterkeyhint: {
        type: PropType<"search" | "next" | "done" | "enter" | "go" | "previous" | "send">;
        validator(val: TdInputProps['enterkeyhint']): boolean;
    };
    format: {
        type: PropType<import("./type").InputFormatType>;
    };
    label: {
        type: PropType<string | ((h: typeof import("vue").h) => import("..").SlotReturnValue)>;
    };
    layout: {
        type: PropType<"vertical" | "horizontal">;
        default: "vertical" | "horizontal";
        validator(val: TdInputProps['layout']): boolean;
    };
    maxcharacter: {
        type: NumberConstructor;
    };
    maxlength: {
        type: PropType<string | number>;
    };
    name: {
        type: StringConstructor;
        default: string;
    };
    placeholder: {
        type: StringConstructor;
        default: any;
    };
    prefixIcon: {
        type: PropType<(h: typeof import("vue").h) => import("..").SlotReturnValue>;
    };
    readonly: {
        type: BooleanConstructor;
        default: any;
    };
    spellCheck: BooleanConstructor;
    status: {
        type: PropType<"default" | "error" | "warning" | "success">;
        default: "default" | "error" | "warning" | "success";
        validator(val: TdInputProps['status']): boolean;
    };
    suffix: {
        type: PropType<string | ((h: typeof import("vue").h) => import("..").SlotReturnValue)>;
    };
    suffixIcon: {
        type: PropType<(h: typeof import("vue").h) => import("..").SlotReturnValue>;
    };
    tips: {
        type: PropType<string | ((h: typeof import("vue").h) => import("..").SlotReturnValue)>;
    };
    type: {
        type: PropType<"number" | "search" | "text" | "hidden" | "submit" | "url" | "password" | "tel">;
        default: "number" | "search" | "text" | "hidden" | "submit" | "url" | "password" | "tel";
        validator(val: TdInputProps['type']): boolean;
    };
    value: {
        type: PropType<import("./type").InputValue>;
        default: any;
    };
    modelValue: {
        type: PropType<import("./type").InputValue>;
        default: any;
    };
    defaultValue: {
        type: PropType<import("./type").InputValue>;
    };
    onBlur: PropType<(value: import("./type").InputValue, context: {
        e: FocusEvent;
    }) => void>;
    onChange: PropType<(value: import("./type").InputValue, context?: {
        e?: MouseEvent | InputEvent | CompositionEvent;
        trigger: "input" | "initial" | "clear";
    }) => void>;
    onClear: PropType<(context: {
        e: TouchEvent;
    }) => void>;
    onFocus: PropType<(value: import("./type").InputValue, context: {
        e: FocusEvent;
    }) => void>;
    onValidate: PropType<(context: {
        error?: "exceed-maximum" | "below-minimum";
    }) => void>;
};
export default _default;
