/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var props = {
  content: {
    type: [String, Function]
  },
  default: {
    type: [String, Function]
  },
  disabled: {
    type: Boolean,
    default: void 0
  },
  hover: Boolean,
  href: {
    type: String,
    default: ""
  },
  prefixIcon: {
    type: Function
  },
  size: {
    type: String,
    default: "medium",
    validator: function validator(val) {
      if (!val) return true;
      return ["small", "medium", "large"].includes(val);
    }
  },
  suffixIcon: {
    type: Function
  },
  target: {
    type: String,
    default: ""
  },
  theme: {
    type: String,
    default: "default",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "primary", "danger", "warning", "success"].includes(val);
    }
  },
  underline: Boolean,
  onClick: Function
};

export { props as default };
//# sourceMappingURL=props.mjs.map
