/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _toConsumableArray } from '../../_chunks/dep-af443fd2.mjs';
import { defineComponent, createVNode } from 'vue';
import config from '../../config.mjs';
import { usePrefixClass } from '../../hooks/useClass.mjs';
import '../../_chunks/dep-3a5e8269.mjs';
import '../../config-provider/useConfig.mjs';
import '../../_chunks/dep-2822c770.mjs';
import '../../_chunks/dep-0f7e0eb1.mjs';
import 'lodash-es';
import '../../config-provider/context.mjs';
import '../../_common/js/global-config/mobile/default-config.mjs';
import '../../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../../_chunks/dep-2a1ce6fa.mjs';
import '../../_chunks/dep-308d506d.mjs';
import '../../_chunks/dep-057983c9.mjs';
import '../../_chunks/dep-735bd654.mjs';
import '../../config-provider/type.mjs';

var prefix = config.prefix;
var SpinnerIcon = defineComponent({
  name: "".concat(prefix, "-spinner"),
  props: {
    style: Object
  },
  setup: function setup(props) {
    var spinnerClass = usePrefixClass("loading__spinner");
    return function () {
      return createVNode("span", {
        "class": spinnerClass.value,
        "style": props.style
      }, [_toConsumableArray(new Array(12)).map(function (_, index) {
        return createVNode("i", {
          "class": ["".concat(spinnerClass.value, "--line"), "".concat(spinnerClass.value, "--line-").concat(index + 1)]
        }, null);
      })]);
    };
  }
});

export { SpinnerIcon as default };
//# sourceMappingURL=spinner.mjs.map
