/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { isArray, get } from 'lodash-es';

var isMultipleArray = function isMultipleArray(arr) {
  return isArray(arr[0]);
};
var getPickerColumns = function getPickerColumns(columns) {
  return isMultipleArray(columns) ? columns : [columns];
};
var limitNumberInRange = function limitNumberInRange(num, min, max) {
  return Math.min(Math.max(num, min), max);
};
function findIndexOfEnabledOption(options, startIndex, keys) {
  var limitStartIndex = limitNumberInRange(startIndex, 0, options.length - 1);
  var forwardIndex = options.findIndex(function (opt, idx) {
    var _keys$disabled;
    return !get(opt, (_keys$disabled = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled !== void 0 ? _keys$disabled : "disabled") && idx >= limitStartIndex;
  });
  if (forwardIndex !== -1) {
    return forwardIndex;
  }
  var backwardIndex = options.slice(0, limitStartIndex).reverse().findIndex(function (opt) {
    var _keys$disabled2;
    return !get(opt, (_keys$disabled2 = keys === null || keys === void 0 ? void 0 : keys.disabled) !== null && _keys$disabled2 !== void 0 ? _keys$disabled2 : "disabled");
  });
  if (backwardIndex !== -1) {
    return limitStartIndex - 1 - backwardIndex;
  }
  return 0;
}

export { findIndexOfEnabledOption, getPickerColumns, isMultipleArray, limitNumberInRange };
//# sourceMappingURL=utils.mjs.map
