/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { _ as _slicedToArray } from '../_chunks/dep-0a95ce1b.mjs';
import { defineComponent, toRefs, computed, provide, createVNode } from 'vue';
import { get } from 'lodash-es';
import props from './radio-group-props.mjs';
import _Radio from './radio.mjs';
import config from '../config.mjs';
import useVModel from '../hooks/useVModel.mjs';
import { usePrefixClass } from '../hooks/useClass.mjs';
import { useTNodeJSX } from '../hooks/tnode.mjs';
import '../_chunks/dep-3a5e8269.mjs';
import '../_chunks/dep-2822c770.mjs';
import '../_chunks/dep-0f7e0eb1.mjs';
import 'tdesign-icons-vue-next';
import './props.mjs';
import '../form/hooks.mjs';
import '../config-provider/useConfig.mjs';
import '../config-provider/context.mjs';
import '../_common/js/global-config/mobile/default-config.mjs';
import '../_common/js/global-config/mobile/locale/zh_CN.mjs';
import '../_chunks/dep-2a1ce6fa.mjs';
import '../_chunks/dep-308d506d.mjs';
import '../_chunks/dep-057983c9.mjs';
import '../_chunks/dep-735bd654.mjs';
import '../config-provider/type.mjs';
import '../hooks/render-tnode.mjs';

var prefix = config.prefix;
var _RadioGroup = defineComponent({
  name: "".concat(prefix, "-radio-group"),
  props: props,
  setup: function setup(props2, context) {
    var renderTNodeJSX = useTNodeJSX();
    var radioGroupClass = usePrefixClass("radio-group");
    var _toRefs = toRefs(props2),
      value = _toRefs.value,
      modelValue = _toRefs.modelValue;
    var _useVModel = useVModel(value, modelValue, props2.defaultValue, props2.onChange),
      _useVModel2 = _slicedToArray(_useVModel, 2),
      groupValue = _useVModel2[0],
      setGroupValue = _useVModel2[1];
    var keys = computed(function () {
      return props2.keys;
    });
    var groupOptions = computed(function () {
      var _props2$options;
      return (_props2$options = props2.options) === null || _props2$options === void 0 ? void 0 : _props2$options.map(function (option) {
        var opt = option;
        if (typeof option === "string" || typeof option === "number") {
          opt = {
            value: option,
            label: option.toString()
          };
        }
        return opt;
      });
    });
    var handleRadioChange = function handleRadioChange(val, context2) {
      if (props2.allowUncheck && val === groupValue.value) {
        setGroupValue("", context2);
      } else {
        setGroupValue(val, context2);
      }
    };
    provide("rootGroupProps", props2);
    provide("rootGroupValue", groupValue);
    provide("rootGroupChange", handleRadioChange);
    return function () {
      return createVNode("div", {
        "class": radioGroupClass.value,
        "role": "radiogroup"
      }, [props2.options && groupOptions.value.map(function (opt, index) {
        var _keys$value$value, _keys$value, _keys$value$disabled, _keys$value2, _keys$value$value2, _keys$value3, _keys$value$label, _keys$value4;
        return createVNode(_Radio, {
          "name": props2.name,
          "icon": props2.icon,
          "checked": groupValue.value === get(opt, (_keys$value$value = (_keys$value = keys.value) === null || _keys$value === void 0 ? void 0 : _keys$value.value) !== null && _keys$value$value !== void 0 ? _keys$value$value : "value"),
          "disabled": get(opt, (_keys$value$disabled = (_keys$value2 = keys.value) === null || _keys$value2 === void 0 ? void 0 : _keys$value2.disabled) !== null && _keys$value$disabled !== void 0 ? _keys$value$disabled : "disabled", props2.disabled),
          "value": get(opt, (_keys$value$value2 = (_keys$value3 = keys.value) === null || _keys$value3 === void 0 ? void 0 : _keys$value3.value) !== null && _keys$value$value2 !== void 0 ? _keys$value$value2 : "value"),
          "label": get(opt, (_keys$value$label = (_keys$value4 = keys.value) === null || _keys$value4 === void 0 ? void 0 : _keys$value4.label) !== null && _keys$value$label !== void 0 ? _keys$value$label : "label"),
          "placement": props2.placement
        }, null);
      }), !props2.options && renderTNodeJSX("default")]);
    };
  }
});

export { _RadioGroup as default };
//# sourceMappingURL=radio-group.mjs.map
