/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { ref, isRef } from 'vue';

function useToggle(values, defaultValue) {
  var innerValues = values || [true, false];
  var state = ref();
  if (defaultValue === void 0) {
    state = ref(innerValues[1]);
  } else if (isRef(defaultValue)) {
    state = defaultValue;
  } else {
    state = ref(defaultValue);
  }
  var toggle = function toggle(value) {
    if (value !== void 0) {
      state.value = value;
    } else {
      state.value = state.value === innerValues[1] ? innerValues[0] : innerValues[1];
    }
  };
  return {
    state: state,
    toggle: toggle
  };
}

export { useToggle };
//# sourceMappingURL=index.mjs.map
