import { TNode } from '../common';
export interface TdSwiperProps {
    animation?: 'slide';
    autoplay?: boolean;
    current?: number;
    defaultCurrent?: number;
    modelValue?: number;
    direction?: 'horizontal' | 'vertical';
    duration?: number;
    height?: number | string;
    interval?: number;
    loop?: boolean;
    navigation?: SwiperNavigation | TNode;
    nextMargin?: string | number;
    previousMargin?: string | number;
    type?: 'default' | 'card';
    onChange?: (current: number, context: {
        source: SwiperChangeSource;
    }) => void;
    onClick?: (index: number) => void;
    disabled?: Boolean;
}
export interface SwiperNavigation {
    minShowNum?: number;
    paginationPosition?: 'top-left' | 'top' | 'top-right' | 'bottom-left' | 'bottom' | 'bottom-right';
    placement?: 'inside' | 'outside';
    showControls?: boolean;
    type?: SwiperNavigationType;
}
export declare type SwiperChangeSource = 'autoplay' | 'touch' | 'nav';
export declare type SwiperNavigationType = 'dots' | 'dots-bar' | 'fraction';
