/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var props = {
  customValue: {
    type: Array
  },
  disabled: {
    type: Boolean,
    default: void 0
  },
  icon: {
    type: Array,
    default: function _default() {
      return [];
    }
  },
  label: {
    type: [Array, Function],
    default: function _default() {
      return [];
    }
  },
  loading: Boolean,
  size: {
    type: String,
    default: "medium",
    validator: function validator(val) {
      if (!val) return true;
      return ["small", "medium", "large"].includes(val);
    }
  },
  value: {
    type: [String, Number, Boolean],
    default: void 0
  },
  modelValue: {
    type: [String, Number, Boolean],
    default: void 0
  },
  defaultValue: {
    type: [String, Number, Boolean]
  },
  onChange: Function
};

export { props as default };
//# sourceMappingURL=props.mjs.map
