/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { ref } from 'vue';
import '../shared/index.js';
import { isBrowser } from '../shared/util.js';
import '../shared/functions.js';
import '../shared/component.js';
import '../shared/constants.js';
import '../config.js';
import '../shared/render.js';
import '@babel/runtime/helpers/typeof';
import 'lodash-es';
import '../shared/dom.js';
import '../shared/render-tnode.js';
import '../shared/useToggle/index.js';
import '../shared/useCountDown/index.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '@vueuse/core';
import '../shared/useCountDown/utils.js';
import '@babel/runtime/helpers/slicedToArray';
import '../shared/useChildSlots/index.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../shared/useTouch/index.js';
import '../shared/useScrollParent/index.js';
import '../shared/useExpose/index.js';
import '../shared/useTest/index.js';
import '@babel/runtime/helpers/defineProperty';
import '../shared/useClickAway/index.js';
import '../shared/useGesture/index.js';
import '@use-gesture/vanilla';
import '../shared/hover.js';

var supportsPassive = ref(false);
if (!isBrowser) {
  try {
    var opts = {};
    Object.defineProperty(opts, "passive", {
      get: function get() {
        supportsPassive.value = true;
        return true;
      }
    });
    window.addEventListener("test-passive", null, opts);
  } catch (e) {}
}

export { supportsPassive };
//# sourceMappingURL=supportsPassive.js.map
