import { TNode, TreeOptionData, TreeKeysType } from '../common';
export interface TdCascaderProps<CascaderOption extends TreeOptionData = TreeOptionData> {
    checkStrictly?: boolean;
    closeBtn?: boolean | TNode;
    header?: TNode;
    keys?: CascaderKeysType;
    middleContent?: TNode;
    options?: Array<CascaderOption>;
    placeholder?: string | TNode;
    subTitles?: Array<string>;
    theme?: 'step' | 'tab';
    title?: string | TNode;
    value?: string | number;
    defaultValue?: string | number;
    modelValue?: string | number;
    visible?: boolean;
    onChange?: (value: string | number, selectedOptions: CascaderOption[]) => void;
    onClose?: (trigger: CascaderTriggerSource) => void;
    onPick?: (context: {
        value: string | number;
        label: string;
        index: number;
        level: number;
    }) => void;
}
export declare type CascaderKeysType = TreeKeysType;
export declare type CascaderTriggerSource = 'overlay' | 'close-btn' | 'finish';
