/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { defineComponent, computed, createVNode } from 'vue';
import props from './cell-group-props.js';
import config from '../config.js';
import { usePrefixClass } from '../hooks/useClass.js';
import { useTNodeJSX } from '../hooks/tnode.js';
import '../config-provider/useConfig.js';
import 'lodash-es';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-1f914f51.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-10ba61db.js';
import 'dayjs';
import '../_chunks/dep-5b3ad5d0.js';
import '../config-provider/type.js';
import '../hooks/render-tnode.js';

var prefix = config.prefix;
var _CellGroup = defineComponent({
  name: "".concat(prefix, "-cell-group"),
  props: props,
  setup: function setup(props2) {
    var renderTNodeJSX = useTNodeJSX();
    var cellGroupClass = usePrefixClass("cell-group");
    var contentClasses = computed(function () {
      return [cellGroupClass.value, "".concat(cellGroupClass.value, "--").concat(props2.theme), _defineProperty({}, "".concat(cellGroupClass.value, "--bordered"), props2.bordered)];
    });
    return function () {
      var title = renderTNodeJSX("title");
      return createVNode("div", null, [title ? createVNode("div", {
        "class": "".concat(cellGroupClass.value, "__title")
      }, [title]) : null, createVNode("div", {
        "class": contentClasses.value
      }, [renderTNodeJSX("default")])]);
    };
  }
});

export { _CellGroup as default };
//# sourceMappingURL=cell-group.js.map
