export declare type TriggerSource = 'overlay' | 'menu' | 'content' | 'confirm' | 'outside';
export declare type DropdownMenuDo = () => void;
export declare type DropdownMenuState = {
    activeId: number | null;
    barRect: any;
    childCount: number;
    itemsLabel: any[];
};
export declare type DropdownMenuControl = {
    expandMenu: (item: any, idx: number) => void;
    collapseMenu: () => void;
    emitEvents: (emit: string, trigger?: TriggerSource) => void;
};
export declare enum DropdownMenuExpandState {
    expanded = "expanded",
    collapsed = "collapsed"
}
export declare type DropdownMenuContext = {
    expandedMenuControl: DropdownMenuControl | null;
    recordMenuExpanded(container: any, menuControl: DropdownMenuControl, action: DropdownMenuExpandState): void;
};
export declare const context: DropdownMenuContext;
