/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import _DropdownMenu from './dropdown-menu.js';
import _DropdownItem from './dropdown-item.js';
import '../shared/index.js';
import './style';
import './type.js';
import { withInstall } from '../shared/component.js';
import '@babel/runtime/helpers/defineProperty';
import 'vue';
import '@vueuse/core';
import 'tdesign-icons-vue-next';
import 'lodash-es';
import '../config.js';
import './context.js';
import './dom-utils.js';
import '../hooks/tnode.js';
import '../hooks/render-tnode.js';
import './props.js';
import '../hooks/useClass.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-1f914f51.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-10ba61db.js';
import 'dayjs';
import '../_chunks/dep-5b3ad5d0.js';
import '../config-provider/type.js';
import '../shared/useExpose/index.js';
import '@babel/runtime/helpers/slicedToArray';
import '../radio/index.js';
import '../radio/radio.js';
import '../radio/props.js';
import '../hooks/useVModel.js';
import '../form/hooks.js';
import '../radio/radio-group.js';
import '../radio/radio-group-props.js';
import '../radio/style';
import '../radio/type.js';
import '../shared/functions.js';
import '../shared/util.js';
import '../shared/constants.js';
import '../shared/render.js';
import '../shared/dom.js';
import '../shared/render-tnode.js';
import '../shared/useToggle/index.js';
import '../shared/useCountDown/index.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '../shared/useCountDown/utils.js';
import '../shared/useChildSlots/index.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../shared/useTouch/index.js';
import '../shared/useScrollParent/index.js';
import '../shared/useTest/index.js';
import '../shared/useClickAway/index.js';
import '../shared/useGesture/index.js';
import '@use-gesture/vanilla';
import '../shared/hover.js';
import '../button/index.js';
import '../button/button.js';
import '../loading/index.js';
import '../loading/loading.js';
import '../loading/icon/gradient.js';
import '../_common/js/loading/circle-adapter.js';
import '../_common/js/utils/setStyle.js';
import '../_common/js/utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import '../loading/icon/spinner.js';
import '../loading/props.js';
import '../loading/style';
import '../loading/type.js';
import '../loading/plugin.js';
import '../button/props.js';
import '../button/style';
import '../button/type.js';
import '../popup/index.js';
import '../popup/popup.js';
import '../popup/props.js';
import '../overlay/index.js';
import '../overlay/overlay.js';
import '../overlay/props.js';
import '../overlay/style';
import '../hooks/useLockScroll.js';
import '../_util/useTouch.js';
import '../_util/getScrollParent.js';
import '../hooks/useTeleport.js';
import '../popup/style';
import '../popup/type.js';
import '../checkbox/index.js';
import '../checkbox/checkbox.js';
import '../checkbox/props.js';
import '../checkbox/checkbox-group.js';
import '../checkbox/checkbox-group-props.js';
import '../checkbox/hooks/index.js';
import '../checkbox/hooks/getOptions.js';
import '../checkbox/hooks/setCheckAllStatus.js';
import '../checkbox/style';
import '../checkbox/type.js';
import './dropdown-item-props.js';

var DropdownMenu = withInstall(_DropdownMenu);
var DropdownItem = withInstall(_DropdownItem);

export { DropdownItem, DropdownMenu, DropdownMenu as default };
//# sourceMappingURL=index.js.map
