/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, getCurrentInstance, inject, createVNode } from 'vue';
import config from '../config.js';
import indexesAnchorProps from './indexes-anchor-props.js';
import { usePrefixClass } from '../hooks/useClass.js';
import { useTNodeJSX } from '../hooks/tnode.js';
import '../config-provider/useConfig.js';
import '@babel/runtime/helpers/defineProperty';
import 'lodash-es';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-1f914f51.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-10ba61db.js';
import 'dayjs';
import '../_chunks/dep-5b3ad5d0.js';
import '../config-provider/type.js';
import '../hooks/render-tnode.js';

var prefix = config.prefix;
var _IndexesAnchor = defineComponent({
  name: "".concat(prefix, "-indexes-anchor"),
  props: indexesAnchorProps,
  setup: function setup(props) {
    var readerTNodeJSX = useTNodeJSX();
    var indexesAnchorClass = usePrefixClass("indexes-anchor");
    var instance = getCurrentInstance();
    var indexesProvide = inject("indexesProvide", void 0);
    var proxy = instance.proxy;
    indexesProvide.relation(proxy);
    return function () {
      return createVNode("div", {
        "class": indexesAnchorClass.value,
        "data-index": props.index
      }, [createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__wrapper")
      }, [createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__slot")
      }, [readerTNodeJSX("default")]), createVNode("div", {
        "class": "".concat(indexesAnchorClass.value, "__header")
      }, [props.index])])]);
    };
  }
});

export { _IndexesAnchor as default };
//# sourceMappingURL=indexes-anchor.js.map
