/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, inject, computed, createVNode } from 'vue';
import '../shared/index.js';
import props from './col-props.js';
import config from '../config.js';
import { rowInjectionKey } from './constants.js';
import { useTNodeJSX } from '../hooks/tnode.js';
import { usePrefixClass } from '../hooks/useClass.js';
import { convertUnit } from '../shared/util.js';
import '../shared/functions.js';
import '../shared/component.js';
import '../shared/constants.js';
import '../shared/render.js';
import '@babel/runtime/helpers/typeof';
import 'lodash-es';
import '../shared/dom.js';
import '../shared/render-tnode.js';
import '../shared/useToggle/index.js';
import '../shared/useCountDown/index.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '@vueuse/core';
import '../shared/useCountDown/utils.js';
import '../shared/useChildSlots/index.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../shared/useTouch/index.js';
import '../shared/useScrollParent/index.js';
import '../shared/useExpose/index.js';
import '../shared/useTest/index.js';
import '@babel/runtime/helpers/defineProperty';
import '../shared/useClickAway/index.js';
import '../shared/useGesture/index.js';
import '@babel/runtime/helpers/slicedToArray';
import '@use-gesture/vanilla';
import '../shared/hover.js';
import '../hooks/render-tnode.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-1f914f51.js';
import '../_chunks/dep-10ba61db.js';
import 'dayjs';
import '../_chunks/dep-5b3ad5d0.js';
import '../config-provider/type.js';

var prefix = config.prefix;
var _Col = defineComponent({
  name: "".concat(prefix, "-col"),
  props: props,
  setup: function setup(props2) {
    var renderTNodeJSX = useTNodeJSX();
    var colClass = usePrefixClass("col");
    var _inject = inject(rowInjectionKey),
      gutter = _inject.gutter;
    var style = computed(function () {
      var styles = {};
      if (!gutter) {
        return styles;
      }
      var gutterVal = convertUnit(Number(gutter) / 2);
      styles.paddingRight = gutterVal;
      styles.paddingLeft = gutterVal;
      return styles;
    });
    var rootClass = computed(function () {
      var rootClass2 = colClass.value;
      if (props2.offset) {
        rootClass2 += " ".concat(colClass.value, "--offset-").concat(props2.offset);
      }
      if (props2.span) {
        rootClass2 += " ".concat(colClass.value, "--").concat(props2.span);
      }
      return rootClass2;
    });
    return function () {
      return createVNode("div", {
        "class": rootClass.value,
        "style": style.value
      }, [renderTNodeJSX("default")]);
    };
  }
});

export { _Col as default };
//# sourceMappingURL=col.js.map
