/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import _toConsumableArray from '@babel/runtime/helpers/toConsumableArray';
import { defineComponent, createVNode } from 'vue';
import config from '../../config.js';
import { usePrefixClass } from '../../hooks/useClass.js';
import '../../config-provider/useConfig.js';
import '@babel/runtime/helpers/defineProperty';
import 'lodash-es';
import '../../config-provider/context.js';
import '../../_common/js/global-config/mobile/default-config.js';
import '../../_common/js/global-config/mobile/locale/zh_CN.js';
import '../../_chunks/dep-1f914f51.js';
import '@babel/runtime/helpers/typeof';
import '../../_chunks/dep-10ba61db.js';
import 'dayjs';
import '../../_chunks/dep-5b3ad5d0.js';
import '../../config-provider/type.js';

var prefix = config.prefix;
var SpinnerIcon = defineComponent({
  name: "".concat(prefix, "-spinner"),
  props: {
    style: Object
  },
  setup: function setup(props) {
    var spinnerClass = usePrefixClass("loading__spinner");
    return function () {
      return createVNode("span", {
        "class": spinnerClass.value,
        "style": props.style
      }, [_toConsumableArray(new Array(12)).map(function (_, index) {
        return createVNode("i", {
          "class": ["".concat(spinnerClass.value, "--line"), "".concat(spinnerClass.value, "--line-").concat(index + 1)]
        }, null);
      })]);
    };
  }
});

export { SpinnerIcon as default };
//# sourceMappingURL=spinner.js.map
