import Message from './message';
import { WithInstallType } from '../shared';
import { TdMessageProps } from './type';
import './style';
interface MessageActionOptionsType extends TdMessageProps {
    context?: Element;
}
declare type MessageApi = {
    info: (options?: MessageActionOptionsType | string) => void;
    success: (options?: MessageActionOptionsType | string) => void;
    warning: (options?: MessageActionOptionsType | string) => void;
    error: (options?: MessageActionOptionsType | string) => void;
    closeAll: () => void;
};
export declare const MessagePlugin: WithInstallType<typeof Message> & MessageApi;
export default MessagePlugin;
declare module 'vue' {
    interface ComponentCustomProperties {
        $message: MessageApi;
    }
}
