/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

export { DialogPlugin as Dialog, DialogPlugin } from './dialog/index.js';
export { MessagePlugin as Message, MessagePlugin } from './message/index.js';
import './toast/index.js';
import './drawer/index.js';
import './loading/index.js';
export { _ActionSheet as ActionSheet } from './action-sheet/index.js';
export { ToastPlugin as Toast, ToastPlugin } from './toast/plugin.js';
export { default as DrawerPlugin } from './drawer/plugin.js';
export { LoadingPlugin } from './loading/plugin.js';
import '@babel/runtime/helpers/defineProperty';
import 'vue';
import './dialog/dialog.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'tdesign-icons-vue-next';
import 'lodash-es';
import './button/index.js';
import './button/button.js';
import './shared/index.js';
import './shared/functions.js';
import './shared/util.js';
import '@babel/runtime/helpers/slicedToArray';
import './config.js';
import './shared/component.js';
import './shared/constants.js';
import './shared/render.js';
import '@babel/runtime/helpers/typeof';
import './shared/dom.js';
import './shared/render-tnode.js';
import './shared/useToggle/index.js';
import './shared/useCountDown/index.js';
import '@babel/runtime/helpers/asyncToGenerator';
import '@babel/runtime/regenerator';
import '@vueuse/core';
import './shared/useCountDown/utils.js';
import './shared/useChildSlots/index.js';
import './shared/useTouch/index.js';
import './shared/useScrollParent/index.js';
import './shared/useExpose/index.js';
import './shared/useTest/index.js';
import './shared/useClickAway/index.js';
import './shared/useGesture/index.js';
import '@use-gesture/vanilla';
import './shared/hover.js';
import './button/props.js';
import './form/hooks.js';
import './hooks/useClass.js';
import './config-provider/useConfig.js';
import './config-provider/context.js';
import './_common/js/global-config/mobile/default-config.js';
import './_common/js/global-config/mobile/locale/zh_CN.js';
import './_chunks/dep-1f914f51.js';
import './_chunks/dep-10ba61db.js';
import 'dayjs';
import './_chunks/dep-5b3ad5d0.js';
import './config-provider/type.js';
import './hooks/tnode.js';
import './hooks/render-tnode.js';
import './loading/loading.js';
import './loading/icon/gradient.js';
import './_common/js/loading/circle-adapter.js';
import './_common/js/utils/setStyle.js';
import './_common/js/utils/helper.js';
import '@babel/runtime/helpers/objectWithoutProperties';
import './loading/icon/spinner.js';
import './loading/props.js';
import './loading/style';
import './loading/type.js';
import './button/style';
import './button/type.js';
import './popup/index.js';
import './popup/popup.js';
import './popup/props.js';
import './overlay/index.js';
import './overlay/overlay.js';
import './overlay/props.js';
import './overlay/style';
import './hooks/useVModel.js';
import './hooks/useLockScroll.js';
import './_util/useTouch.js';
import './_util/getScrollParent.js';
import './hooks/useTeleport.js';
import './popup/style';
import './popup/type.js';
import './dialog/props.js';
import './dialog/style';
import './message/message.js';
import './link/index.js';
import './link/link.js';
import './link/props.js';
import './link/style';
import './link/type.js';
import './message/props.js';
import './message/style';
import './toast/style';
import './toast/type.js';
import './toast/toast.js';
import './toast/props.js';
import './drawer/drawer.js';
import './drawer/props.js';
import './drawer/style';
import './drawer/type.js';
import './action-sheet/action-sheet.js';
import './action-sheet/action-sheet-grid.js';
import './grid/index.js';
import './grid/grid.js';
import './grid/props.js';
import './grid/grid-item.js';
import './grid/grid-item-props.js';
import './image/index.js';
import './image/image.js';
import './image/props.js';
import './image/style';
import './image/type.js';
import './badge/index.js';
import './badge/badge.js';
import './badge/props.js';
import './badge/style';
import './badge/type.js';
import './grid/style';
import './grid/type.js';
import './swiper/index.js';
import './swiper/swiper.js';
import './swipe-cell/useSwipe.js';
import './swiper/props.js';
import './swiper/swiper-item.js';
import './swiper/style';
import './swiper/type.js';
import './action-sheet/action-sheet-list.js';
import './action-sheet/props.js';
import './action-sheet/style';
import './action-sheet/type.js';
//# sourceMappingURL=plugins.js.map
