/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var props = {
  allowUncheck: Boolean,
  borderless: Boolean,
  disabled: {
    type: Boolean,
    default: void 0
  },
  icon: {
    type: [String, Array],
    default: "circle"
  },
  keys: {
    type: Object
  },
  name: {
    type: String,
    default: ""
  },
  options: {
    type: Array
  },
  placement: {
    type: String,
    default: "left",
    validator: function validator(val) {
      if (!val) return true;
      return ["left", "right"].includes(val);
    }
  },
  readonly: {
    type: Boolean,
    default: void 0
  },
  value: {
    type: [String, Number, Boolean],
    default: void 0
  },
  modelValue: {
    type: [String, Number, Boolean],
    default: void 0
  },
  defaultValue: {
    type: [String, Number, Boolean]
  },
  onChange: Function
};

export { props as default };
//# sourceMappingURL=radio-group-props.js.map
