/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var props = {
  current: {
    type: [String, Number],
    default: void 0
  },
  modelValue: {
    type: [String, Number],
    default: void 0
  },
  defaultCurrent: {
    type: [String, Number]
  },
  currentStatus: {
    type: String,
    default: "process",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "process", "finish", "error"].includes(val);
    }
  },
  layout: {
    type: String,
    default: "horizontal",
    validator: function validator(val) {
      if (!val) return true;
      return ["horizontal", "vertical"].includes(val);
    }
  },
  readonly: {
    type: Boolean,
    default: void 0
  },
  sequence: {
    type: String,
    default: "positive",
    validator: function validator(val) {
      if (!val) return true;
      return ["positive", "reverse"].includes(val);
    }
  },
  theme: {
    type: String,
    default: "default",
    validator: function validator(val) {
      if (!val) return true;
      return ["default", "dot"].includes(val);
    }
  },
  onChange: Function
};

export { props as default };
//# sourceMappingURL=props.js.map
