/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, inject, computed, ref, watch, withDirectives, createVNode, vShow } from 'vue';
import config from '../config.js';
import props from './tab-panel-props.js';
import { useContent } from '../hooks/tnode.js';
import { usePrefixClass } from '../hooks/useClass.js';
import 'lodash-es';
import '../hooks/render-tnode.js';
import '../config-provider/useConfig.js';
import '@babel/runtime/helpers/defineProperty';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-1f914f51.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-10ba61db.js';
import 'dayjs';
import '../_chunks/dep-5b3ad5d0.js';
import '../config-provider/type.js';

var prefix = config.prefix;
var name = "".concat(prefix, "-tab-panel");
var _TabPanel = defineComponent({
  name: name,
  props: props,
  setup: function setup(props2) {
    var renderTNodeContent = useContent();
    var tabPanelClass = usePrefixClass("tab-panel");
    var tabsClass = usePrefixClass("tabs");
    var currentValue = inject("currentValue");
    var isActive = computed(function () {
      return currentValue.value === props2.value;
    });
    var tabPanelClasses = computed(function () {
      return ["".concat(tabPanelClass.value), "".concat(tabsClass.value, "__panel")];
    });
    var isMount = ref(props2.lazy ? isActive.value : true);
    watch(isActive, function () {
      if (isActive.value) {
        if (!isMount.value) {
          isMount.value = true;
        }
      } else if (props2.destroyOnHide) {
        isMount.value = false;
      }
    }, {
      immediate: true
    });
    return function () {
      if (!isMount.value) return null;
      return withDirectives(createVNode("div", {
        "class": tabPanelClasses.value
      }, [renderTNodeContent("default", "panel")]), [[vShow, isActive.value]]);
    };
  }
});

export { _TabPanel as default };
//# sourceMappingURL=tab-panel.js.map
