import { StickyProps } from '../sticky';
import { TNode } from '../common';
export interface TdTabsProps {
    animation?: TabAnimation;
    bottomLineMode?: 'fixed' | 'auto' | 'full';
    list?: Array<TdTabPanelProps>;
    middle?: TNode;
    showBottomLine?: boolean;
    size?: 'medium' | 'large';
    spaceEvenly?: boolean;
    split?: boolean;
    sticky?: boolean;
    stickyProps?: StickyProps;
    swipeable?: boolean;
    theme?: 'line' | 'tag' | 'card';
    value?: TabValue;
    defaultValue?: TabValue;
    modelValue?: TabValue;
    onChange?: (value: TabValue, label: string) => void;
    onClick?: (value: TabValue, label: string) => void;
    onScroll?: (scrollTop: number, isFixed: boolean) => void;
}
export interface TdTabPanelProps {
    badgeProps?: object;
    destroyOnHide?: boolean;
    disabled?: boolean;
    icon?: TNode;
    label?: string | TNode;
    lazy?: boolean;
    panel?: string | TNode;
    value?: TabValue;
}
export declare type TabAnimation = {
    duration: number;
} & Record<string, any>;
export declare type TabValue = string | number;
