import vueToast from './toast';
import { ToastOptions } from './type';
import { WithInstallType } from '../shared';
export declare type ToastProps = ToastOptions;
declare type ToastApi = {
    (options?: Partial<ToastOptions> | string): void;
    loading: (options?: Partial<ToastOptions> | string) => void;
    success: (options?: Partial<ToastOptions> | string) => void;
    warning: (options?: Partial<ToastOptions> | string) => void;
    error: (options?: Partial<ToastOptions> | string) => void;
    clear: () => void;
};
export declare const ToastPlugin: WithInstallType<typeof vueToast> & ToastApi;
export default ToastPlugin;
declare module 'vue' {
    interface ComponentCustomProperties {
        $toast: ToastApi;
    }
}
