import { BadgeProps } from '../badge';
import { PopupProps } from '../popup';
import { TNode } from '../common';
export interface TdActionSheetProps {
    align?: 'center' | 'left';
    cancelText?: string;
    count?: number;
    description?: string;
    items?: Array<string | ActionSheetItem>;
    popupProps?: PopupProps;
    showCancel?: boolean;
    showOverlay?: boolean;
    theme?: 'list' | 'grid';
    visible: boolean;
    defaultVisible: boolean;
    modelValue: boolean;
    onCancel?: (context: {
        e: MouseEvent;
    }) => void;
    onClose?: (trigger: ActionSheetTriggerSource) => void;
    onSelected?: (selected: ActionSheetItem | string, index: number) => void;
}
export interface ActionSheetItem {
    label: string;
    color?: string;
    disabled?: boolean;
    icon?: TNode;
    badge?: BadgeProps;
}
export declare type ActionSheetTriggerSource = 'overlay' | 'command' | 'select';
