import { TNode } from '../common';
export interface TdDateTimePickerProps {
    cancelBtn?: string;
    confirmBtn?: string;
    end?: string | number;
    footer?: TNode;
    format?: string;
    header?: TNode;
    mode?: DateTimePickerMode;
    renderLabel?: (type: string, value: number) => string;
    showWeek?: boolean;
    start?: string | number;
    steps?: {
        [key in TimeModeValues]?: number;
    };
    title?: string;
    value?: DateValue;
    defaultValue?: DateValue;
    modelValue?: DateValue;
    onCancel?: (context: {
        e: MouseEvent;
    }) => void;
    onChange?: (value: DateValue) => void;
    onConfirm?: (value: DateValue) => void;
    onPick?: (value: DateValue) => void;
}
export declare type DateTimePickerMode = TimeModeValues | Array<TimeModeValues>;
export declare type TimeModeValues = 'year' | 'month' | 'date' | 'hour' | 'minute' | 'second';
export declare type DateValue = string | number;
