/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { defineComponent, computed, createVNode } from 'vue';
import config from '../config.js';
import DividerProps from './props.js';
import { useContent } from '../hooks/tnode.js';
import { usePrefixClass } from '../hooks/useClass.js';
import 'lodash-es';
import '../hooks/render-tnode.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-f8b538c0.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-53f63811.js';
import 'dayjs';

var prefix = config.prefix;
var _Divider = defineComponent({
  name: "".concat(prefix, "-divider"),
  props: DividerProps,
  setup: function setup(props) {
    var renderTNodeContent = useContent();
    var dividerClass = usePrefixClass("divider");
    var dividerClasses = computed(function () {
      return ["".concat(dividerClass.value), "".concat(dividerClass.value, "--").concat(props.layout), "".concat(dividerClass.value, "--").concat(props.align), _defineProperty({}, "".concat(dividerClass.value, "--dashed"), props.dashed)];
    });
    return function () {
      var content = renderTNodeContent("default", "content");
      return createVNode("div", {
        "class": dividerClasses.value,
        "role": "separator"
      }, [createVNode("div", {
        "class": "".concat(dividerClass.value, "__content")
      }, [content])]);
    };
  }
});

export { _Divider as default };
//# sourceMappingURL=divider.js.map
