/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var DividerProps = {
  align: {
    type: String,
    default: "center",
    validator: function validator(val) {
      if (!val) return true;
      return ["left", "right", "center"].includes(val);
    }
  },
  content: {
    type: [String, Function]
  },
  dashed: Boolean,
  default: {
    type: [String, Function]
  },
  layout: {
    type: String,
    default: "horizontal",
    validator: function validator(val) {
      if (!val) return true;
      return ["horizontal", "vertical"].includes(val);
    }
  }
};

export { DividerProps as default };
//# sourceMappingURL=props.js.map
