/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, computed, provide, createVNode } from 'vue';
import props from './row-props.js';
import config from '../config.js';
import { rowInjectionKey } from './constants.js';
import { useTNodeJSX } from '../hooks/tnode.js';
import { usePrefixClass } from '../hooks/useClass.js';
import { convertUnit } from '../shared/util.js';
import 'lodash-es';
import '../hooks/render-tnode.js';
import '../config-provider/useConfig.js';
import '@babel/runtime/helpers/defineProperty';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-f8b538c0.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-53f63811.js';
import 'dayjs';
import '@babel/runtime/helpers/slicedToArray';

var prefix = config.prefix;
var _Row = defineComponent({
  name: "".concat(prefix, "-row"),
  props: props,
  setup: function setup(props2) {
    var renderTNodeJSX = useTNodeJSX();
    var rowClass = usePrefixClass("row");
    var style = computed(function () {
      var styles = {};
      if (!props2.gutter) {
        return styles;
      }
      var gutterVal = convertUnit(-props2.gutter / 2);
      styles.marginRight = gutterVal;
      styles.marginLeft = gutterVal;
      return styles;
    });
    provide(rowInjectionKey, {
      gutter: props2.gutter || 0
    });
    return function () {
      return createVNode("div", {
        "class": rowClass.value,
        "style": style.value
      }, [renderTNodeJSX("default")]);
    };
  }
});

export { _Row as default };
//# sourceMappingURL=row.js.map
