/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

var props = {
  allowHalf: Boolean,
  color: {
    type: [String, Array],
    default: "#ED7B2F"
  },
  count: {
    type: Number,
    default: 5
  },
  disabled: {
    type: Boolean,
    default: void 0
  },
  gap: {
    type: [String, Number],
    default: 8
  },
  icon: {
    type: [Array, Function]
  },
  placement: {
    type: String,
    default: "top",
    validator: function validator(val) {
      if (!val) return true;
      return ["top", "bottom", ""].includes(val);
    }
  },
  showText: Boolean,
  size: {
    type: String,
    default: "24px"
  },
  texts: {
    type: Array,
    default: function _default() {
      return [];
    }
  },
  value: {
    type: Number,
    default: void 0
  },
  modelValue: {
    type: Number,
    default: void 0
  },
  defaultValue: {
    type: Number,
    default: 0
  },
  onChange: Function
};

export { props as default };
//# sourceMappingURL=props.js.map
