/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import { defineComponent, toRefs, ref, computed, provide, createVNode } from 'vue';
import TabBarProps from './props.js';
import config from '../config.js';
import useVModel from '../hooks/useVModel.js';
import { useTNodeJSX } from '../hooks/tnode.js';
import { usePrefixClass } from '../hooks/useClass.js';
import { useChildSlots } from '../shared/useChildSlots/index.js';
import 'lodash-es';
import '../hooks/render-tnode.js';
import '../config-provider/useConfig.js';
import '../config-provider/context.js';
import '../_common/js/global-config/mobile/default-config.js';
import '../_common/js/global-config/mobile/locale/zh_CN.js';
import '../_chunks/dep-f8b538c0.js';
import '@babel/runtime/helpers/typeof';
import '../_chunks/dep-53f63811.js';
import 'dayjs';
import '@babel/runtime/helpers/toConsumableArray';

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var prefix = config.prefix;
var _TabBar = defineComponent({
  name: "".concat(prefix, "-tab-bar"),
  props: TabBarProps,
  emits: ["update:value", "update:modelValue", "change"],
  setup: function setup(props, context) {
    var tabBarClass = usePrefixClass("tab-bar");
    var renderTNodeJSX = useTNodeJSX();
    var _toRefs = toRefs(props),
      value = _toRefs.value,
      modelValue = _toRefs.modelValue;
    var _useVModel = useVModel(value, modelValue, props.defaultValue, props.onChange),
      _useVModel2 = _slicedToArray(_useVModel, 2),
      activeValue = _useVModel2[0],
      setActiveValue = _useVModel2[1];
    var defaultIndex = ref(-1);
    var itemCount = ref(0);
    var updateChild = function updateChild(currentValue) {
      setActiveValue(currentValue);
    };
    var rootClass = computed(function () {
      return ["".concat(tabBarClass.value), _defineProperty(_defineProperty(_defineProperty({}, "".concat(tabBarClass.value, "--bordered"), props.bordered), "".concat(tabBarClass.value, "--fixed"), props.fixed), "".concat(tabBarClass.value, "--safe"), props.safeAreaInsetBottom), "".concat(tabBarClass.value, "--").concat(props.shape)];
    });
    provide("tab-bar", _objectSpread(_objectSpread({}, toRefs(props)), {}, {
      defaultIndex: defaultIndex,
      activeValue: activeValue,
      itemCount: itemCount,
      updateChild: updateChild
    }));
    var updateItemCount = function updateItemCount(vNodes) {
      if (!vNodes || !Array.isArray(vNodes)) {
        itemCount.value = 0;
        return;
      }
      var childSlots = useChildSlots("".concat(prefix, "-tab-bar-item"), vNodes);
      itemCount.value = childSlots.length;
    };
    return function () {
      var vNodes = context.slots.default ? context.slots.default() : [];
      updateItemCount(vNodes);
      return createVNode("div", {
        "class": rootClass.value,
        "role": "tablist"
      }, [renderTNodeJSX("default")]);
    };
  }
});

export { _TabBar as default };
//# sourceMappingURL=tab-bar.js.map
