/**
 * tdesign v1.9.0
 * (c) 2025 TDesign Group
 * @license MIT
 */

import { defineComponent, createVNode } from 'vue';
import config from '../config.js';
import props from './tab-panel-props.js';
import { useTNodeJSX, useContent } from '../hooks/tnode.js';
import 'lodash-es';
import '../hooks/render-tnode.js';

var prefix = config.prefix;
var TTabNavItem = defineComponent({
  name: "".concat(prefix, "-tab-nav"),
  props: {
    label: props.label,
    icon: props.icon
  },
  setup: function setup(props) {
    var renderTNodeJSX = useTNodeJSX();
    var renderTNodeContent = useContent();
    return function () {
      return createVNode("div", null, [renderTNodeJSX("icon"), renderTNodeContent("default", "label")]);
    };
  }
});

export { TTabNavItem as default };
//# sourceMappingURL=tab-nav-item.js.map
