import { TreeOptionData, TreeKeysType, PlainObject } from '../common';
export declare type _TreeOptionData<T = string | number> = {
    children?: Array<TreeOptionData<T>> | boolean;
    label?: any;
    text?: string;
    value?: T;
} & PlainObject;
export interface TdTreeSelectProps<DataOption extends _TreeOptionData = _TreeOptionData> {
    customStyle?: string;
    filterable?: boolean;
    height?: string | number;
    keys?: TreeKeysType;
    multiple?: boolean;
    options?: Array<DataOption>;
    value?: TreeSelectValue;
    defaultValue?: TreeSelectValue;
    modelValue?: TreeSelectValue;
    onChange?: (value: TreeSelectValue, level: TreeLevel) => void;
}
export declare type TreeSelectValue = string | number | Array<TreeSelectValue>;
export declare type TreeLevel = 0 | 1 | 2;
